package xmlcaviargui;

import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.imageio.*;
import java.io.*;
import java.util.*;
//import java.awt.event.KeyEvent;

/** 
 * Used the panel where annotations to the jpg image file are
 * stored.
 * @author Donald Nairn
 * @version 1.0
 */

public class ImagePanel extends JPanel {
    
    /** 
     * Used to store modifications so far without writing them to disk.
     */
    protected AllData allData = new AllData();

    /**
     * Mouse listener used for listening to mouse actions on the canvas.
     */
    private IPanelMouseListener mouseListener;

    /**
     * Image file to be loaded 
     */
    private File imageFile;

    /** name of sequence of frame which is being edited.
     */
    private String seqName;

    /**
     * name of file being edited
     */
    private String fileName;

    /**
     * Image object for the image sequence being currently edited
     */
    private Image image;

    /** points for when mouse is clicked on the canvas
     */
    private Point point1, point2;		//the coordinates are in pixels, which is currently the double of the value, due to the scale

    /** 
     * The Canvas where the Image object will be loaded into
     */
    private DrawCanvas canvas;

    /** current id of the frame being edited.
     */
    protected int id,previd,prevselected;

    /** Flag to indicate the current maximum frame that has been edited. */
    protected int max;

    /** flag for whether the number of images is in the hundreds or thousands,
     * for use by load and save file operations.
     */
     protected boolean hundreds;

    /** JLabel used to store data about the frame currently being edited
     */
    private JLabel frameNumber;

    /** Used for editing the position of the box on the screen
     */
    private JPanel X1, X2, Y1, Y2, alterDimensions, alterX, alterY1, alterY2;

    /** Buttons for adding or subtracting to the coordinates of the
     * given line on the screen
     */
    private JButton plusX1, minusX1, plusY1, minusY1,
	plusX2, minusX2, plusY2, minusY2, supfit;

    /** Represents the Box label used in the resize box panel */
    private JButton box;

    /**  */
    private JTextField updateX1, updateX2, updateY1, updateY2;

    //PTC

    private boolean performCheck = false;

	private JPanel alterBody,alterControls;
	
	private BodyCanvas bodycanvas;

	private supfitAction supfitAction;
	private plusX1Action plusX1Action;
	private plusY1Action plusY1Action;
	private plusX2Action plusX2Action;
	private plusY2Action plusY2Action;
	private minusX1Action minusX1Action;
	private minusY1Action minusY1Action;
	private minusX2Action minusX2Action;
	private minusY2Action minusY2Action;
						
	
	private int bodyPartSelected=1;
	public static final int BODY_SEL_BOX=1;
	public static final int BODY_SEL_HEAD=2;
	public static final int BODY_SEL_GAZE=3;
	public static final int BODY_SEL_RIGHT_SHOULDER=4;
	public static final int BODY_SEL_LEFT_SHOULDER=5;
	public static final int BODY_SEL_RIGHT_HAND=6;
	public static final int BODY_SEL_LEFT_HAND=7;
	public static final int BODY_SEL_RIGHT_FOOT=8;
	public static final int BODY_SEL_LEFT_FOOT=9;
	
	private int DELTA=1;	//defines the change when the arrow key is pressed

	private CAVIARGUI caviargui;
	
	public int getbodyPartSelected(){
		return bodyPartSelected;
	}
	
	public void setDelta(int delta){
		this.DELTA=delta;
	}
	
	public boolean getbodyPartSelectedState(){
		boolean state=false;
		int bodyPartSelected=getbodyPartSelected();
		if (bodyPartSelected!=BODY_SEL_BOX){
			SingleBox single=getSingleBoxSelected();
			if (single!=null){
				Body body=single.getBody();
				switch(bodyPartSelected){
					case BODY_SEL_HEAD:state=body.isVisiblehead();break;
					case BODY_SEL_GAZE:state=true;break;
					case BODY_SEL_RIGHT_SHOULDER:state=body.isVisiblerightshoulder();break;
					case BODY_SEL_LEFT_SHOULDER:state=body.isVisibleleftshoulder();break;
					case BODY_SEL_RIGHT_HAND:state=body.isVisiblerighthand();break;
					case BODY_SEL_LEFT_HAND:state=body.isVisiblelefthand();break;
					case BODY_SEL_RIGHT_FOOT:state=body.isVisiblerightfoot();break;
					case BODY_SEL_LEFT_FOOT:state=body.isVisibleleftfoot();break;
				}
				if (state==true){
					state=false;
				}else{
					state=true;
				}
			}
		}
		return state;				
	}

	public boolean bodyPartSelectedisDraw(){
		boolean state=true;
		int bodyPartSelected=getbodyPartSelected();
		if (bodyPartSelected!=BODY_SEL_BOX){
			SingleBox single=getSingleBoxSelected();
			Body body=single.getBody();
			switch(bodyPartSelected){
				case BODY_SEL_HEAD:state=body.isHeadDraw();break;
//				case BODY_SEL_GAZE:body.setVisiblehead(occluded);break;
				case BODY_SEL_RIGHT_SHOULDER:state=body.isShouldersDraw();break;
				case BODY_SEL_LEFT_SHOULDER:state=body.isShouldersDraw();break;
				case BODY_SEL_RIGHT_HAND:state=body.isRightHandDraw();break;
				case BODY_SEL_LEFT_HAND:state=body.isLeftHandDraw();break;
				case BODY_SEL_RIGHT_FOOT:state=body.isRightFootDraw();break;
				case BODY_SEL_LEFT_FOOT:state=body.isLeftFootDraw();break;
			}
		}
		return state;				
	}

	private void updateRatioforSelectedCircle(int value){
		if (isASingleBoxSelected()){
			if (bodyPartSelectedisCircle()){
				int bodyPartSelected=getbodyPartSelected();		
				SingleBox single=getSingleBoxSelected();
				Body body=single.getBody();	
				Circle circle=null;
				switch (bodyPartSelected){
					case BODY_SEL_HEAD:circle=body.getHead();break;
					case BODY_SEL_RIGHT_HAND:circle=body.getRighthand();break;
					case BODY_SEL_LEFT_HAND:circle=body.getLefthand();break;
					case BODY_SEL_RIGHT_FOOT:circle=body.getRightfoot();break;
					case BODY_SEL_LEFT_FOOT:circle=body.getLeftfoot();break;									
				}
				if (circle==null){
					JOptionPane.showMessageDialog(null,("circle not yet draw,first draw the initial circle"),
									  "Ratio Warning", JOptionPane.WARNING_MESSAGE);			
				}else{
					System.out.println("\nThe circle loaded values are "+circle.getX()+" y "+circle.getY()+" r= "+circle.getR()+"\n");
					circle.setR(circle.getR()+value);
					circle=FitCircleInBox(circle,single.getBox());
					if (circle!=null)
						if (circle.getR()<=0){
							circle=null;
							JOptionPane.showMessageDialog(null,("Circle ratio=0; reseting circle"),
											  "Ratio Warning", JOptionPane.WARNING_MESSAGE);								
						}
					if (circle!=null){
						this.point1=new Point(circle.getX()*CAVIARGUI.SCALE,circle.getY()*CAVIARGUI.SCALE);
						this.point2=new Point((circle.getX()+circle.getR())*CAVIARGUI.SCALE,circle.getY()*CAVIARGUI.SCALE);
						System.out.println("coordinates for circle are "+circle.getX()+" y "+circle.getY()+" r "+circle.getR());
					}else{
						this.point1=null;
						this.point2=null;						
					}		
					drawBody(false);
				}				
			}else{
				JOptionPane.showMessageDialog(null,("First select a circle to update its ratio "),
								  "Ratio Warning", JOptionPane.WARNING_MESSAGE);			
			}	
		}else{
			JOptionPane.showMessageDialog(null,("First select a single box to update its ratio "),
							  "Ratio Warning", JOptionPane.WARNING_MESSAGE);			
		}
	}
	
	private void updateGaze(int i){
		if (isASingleBoxSelected()){
			SingleBox single=getSingleBoxSelected();
			Body body=single.getBody();
			int gaze=body.getGaze();			
			if (gaze!=-1){		
				gaze+=i;
				if (gaze>360)
					gaze-=360;
				if (gaze<0)
					gaze+=360;
			}else{
				JOptionPane.showMessageDialog(null,("Gaze has not been set"),
								  "Ratio Warning", JOptionPane.WARNING_MESSAGE);			
			}
			body.setGaze(gaze);	
		}else{
			JOptionPane.showMessageDialog(null,("First select a single box to update its ratio "),
							  "Ratio Warning", JOptionPane.WARNING_MESSAGE);			
		}
		drawBody(false);
	}

	public void setBodyPartState(boolean occluded){
		if (bodyPartSelected!=BODY_SEL_BOX){
			SingleBox single=getSingleBoxSelected();
			Body body=single.getBody();
			switch(bodyPartSelected){
				case BODY_SEL_HEAD:body.setVisiblehead(occluded);break;
//				case BODY_SEL_GAZE:body.setVisiblehead(occluded);break;
				case BODY_SEL_RIGHT_SHOULDER:body.setVisiblerightshoulder(occluded);break;
				case BODY_SEL_LEFT_SHOULDER:body.setVisibleleftshoulder(occluded);break;
				case BODY_SEL_RIGHT_HAND:body.setVisiblerighthand(occluded);break;
				case BODY_SEL_LEFT_HAND:body.setVisiblelefthand(occluded);break;
				case BODY_SEL_RIGHT_FOOT:body.setVisiblerightfoot(occluded);break;
				case BODY_SEL_LEFT_FOOT:body.setVisibleleftfoot(occluded);break;
			}
		}
	}
	
	public void refreshScreen(){
		if (bodyPartSelected==BODY_SEL_BOX)	{
			//drawRect();
		}else
			drawBody(false);	
	}

	public void updateBodyPartSelected(int BodyPart,SingleBox singlebox){
		this.bodyPartSelected=BodyPart;
//		System.out.println("in UpdateBodyPartSelected for bodypart "+BodyPart);
		if (BodyPart==BODY_SEL_BOX){
			Rectangle box=singlebox.getBox();
			this.point1=new Point((int)box.getX()*CAVIARGUI.SCALE,(int)box.getY()*CAVIARGUI.SCALE);
			this.point2=new Point((int)(box.getX()+box.getWidth())*CAVIARGUI.SCALE,(int)(box.getY()+box.getHeight())*CAVIARGUI.SCALE);
			drawRect();			
			
		}else if (bodyPartSelectedisCircle()){
			Body body=singlebox.getBody();
			Circle circle=null;
			switch (bodyPartSelected) {
						case BODY_SEL_HEAD: circle=body.getHead(); break;
						case BODY_SEL_RIGHT_HAND:circle=body.getRighthand();break;
						case BODY_SEL_LEFT_HAND:circle=body.getLefthand();break;
						case BODY_SEL_RIGHT_FOOT:circle=body.getRightfoot();break;
						case BODY_SEL_LEFT_FOOT:circle=body.getLeftfoot();break;
			}
			if (circle!=null){
				this.point1=new Point((int)circle.getX()*CAVIARGUI.SCALE,(int)circle.getY()*CAVIARGUI.SCALE);		
				this.point2=new Point((int)(circle.getX()+circle.getR())*CAVIARGUI.SCALE,(int)circle.getY()*CAVIARGUI.SCALE);
				drawBody(false);		
			}else{
				JOptionPane.showMessageDialog(null,("Element not drawn, draw the element"),
								  "Drawing Warning", JOptionPane.WARNING_MESSAGE);
				this.point1=null;this.point2=null;
				canvas.drawBody(null,allData.frameData[id],false);				  
					
			}
		}else if (bodyPartSelectedisLine()){
			Body body=singlebox.getBody();
			Line2D.Float sh=null;
			if ((bodyPartSelected==BODY_SEL_RIGHT_SHOULDER) || (bodyPartSelected==BODY_SEL_LEFT_SHOULDER)){
				if (body.isShouldersDraw()){
					sh=body.getShoulderLine();
					if (bodyPartSelected==BODY_SEL_RIGHT_SHOULDER){
						this.point1=new Point((int)sh.getX1()*CAVIARGUI.SCALE,(int)sh.getY1()*CAVIARGUI.SCALE);		
						this.point2=new Point((int)sh.getX2()*CAVIARGUI.SCALE,(int)sh.getY2()*CAVIARGUI.SCALE);
					}
					if (bodyPartSelected==BODY_SEL_LEFT_SHOULDER){
						this.point1=new Point((int)sh.getX2()*CAVIARGUI.SCALE,(int)sh.getY2()*CAVIARGUI.SCALE);		
						this.point2=new Point((int)sh.getX1()*CAVIARGUI.SCALE,(int)sh.getY1()*CAVIARGUI.SCALE);
					}	
				drawBody(false);
				}else{
					JOptionPane.showMessageDialog(null,("Element not drawn, draw the element"),
									  "Drawing Warning", JOptionPane.WARNING_MESSAGE);
					this.point1=null;this.point2=null;
					canvas.drawBody(null,allData.frameData[id],false);				
				}
			}
		}else if (bodyPartSelected==BODY_SEL_GAZE){
			Body body=singlebox.getBody();			
			if (body.isHeadDraw()){
				int gaze=body.getGaze();
				if (body.isGazeDraw()==false){	
					System.out.println("prev value from gaze is "+body.getGaze());				
					String gazeStr = JOptionPane.showInputDialog(this,
											 ("Enter the initial angle for gaze"),
										   "Gaze",
										   JOptionPane.PLAIN_MESSAGE);
		    
					if ((gazeStr != null) && (gazeStr.length() > 0)) {
						try {
						gaze = Integer.parseInt(gazeStr);
						if ((gaze<0) || (gaze>360)){
							gaze=-1;
							JOptionPane.showMessageDialog(this,
											  ("gaze value should be between 0-360"),
											  "WARNING",
											  JOptionPane.WARNING_MESSAGE);							
						}

						} catch (NumberFormatException nfe) {
						JOptionPane.showMessageDialog(this,
										  ("Not a number: "+gazeStr),
										  "WARNING",
										  JOptionPane.WARNING_MESSAGE);
						}
					} else {
						JOptionPane.showMessageDialog(this,
									  ("No gaze value specified"),
									  "WARNING",
									  JOptionPane.WARNING_MESSAGE);
					}			
	
				}
				body.setGaze(gaze);
//				System.out.println("Setting gaze to "+gaze);	
				drawBody(false);				
			}else{
				JOptionPane.showMessageDialog(null,("To set the gaze, first set the head"),
								  "Drawing Warning", JOptionPane.WARNING_MESSAGE);	
				//bodyPartSelected=BODY_SEL_HEAD;	
				//bodyPartSelected=BODY_SEL_RIGHT_SHOULDER;
				updateBodyPartSelected(BODY_SEL_RIGHT_SHOULDER,singlebox);			  					
			}

		}	
	}

	private int getCircleTypeforSelection(){
		int circleType=-1;
		if (bodyPartSelected==BODY_SEL_HEAD)
			circleType=Circle.HEAD;
		if (bodyPartSelected==BODY_SEL_RIGHT_HAND)
			circleType=Circle.RIGHTHAND;
		if (bodyPartSelected==BODY_SEL_LEFT_HAND)
			circleType=Circle.LEFTHAND;	
		if (bodyPartSelected==BODY_SEL_RIGHT_FOOT)
			circleType=Circle.RIGHTFOOT;
		if (bodyPartSelected==BODY_SEL_LEFT_FOOT)
			circleType=Circle.LEFTFOOT;				
		return circleType;
	}


	private boolean insideBoxCoordinates(int x,int y,Rectangle box){
		if ((x>box.getX()) && (x<(box.getX()+box.getWidth())) 
			&& (y>box.getY()) && (y<(box.getY()+box.getHeight())))	
			return true;
		else
			return false;	
	}	

	private Point fitCoordinatestoBox(int x,int y,Rectangle box){
//		System.out.println(" coordinates "+x+" y "+y);
//		System.out.println("box is "+box.getX()+" "+box.getY()+" ancho "+box.getWidth()+" alto "+box.getHeight());
		Point p=null;
		if (x<box.getX())
			x=(int)box.getX();
		if (x>(box.getX()+box.getWidth()))
			x=(int)(box.getX()+box.getWidth());
		if (y<box.getY())
			y=(int)box.getY();
		if (y>(box.getY()+box.getHeight()))
			y=(int)(box.getY()+box.getHeight());
//		System.out.println(" After adjusting coordinates "+x+" y "+y);		
		p=new Point(x,y);
		return p;
	}		

	private boolean isBodyforCurrentBoxSelectedEmpty(){
		boolean bodyEmpty=true;
		if (isASingleBoxSelected()){
			SingleBox single=getSingleBoxSelected();
			if (single!=null)
				if (single.isBodyEmpty()==false)		
					bodyEmpty=false;
		}
		return bodyEmpty;
	}
	
	/** 
	 * Embedded class used for the mouse listener on the DrawCanvas object .
	 */
    
	class IPanelMouseListener extends MouseInputAdapter {
    	
	/** 
	 * Called when the mouse is pressed over the DrawCanvas object canvas,
	 * sets initial point of rectangle.
	 */
	public void mousePressed(MouseEvent e) {
		// so coordinates move in two
		Point temp = e.getPoint();		
		if (bodyPartSelected!=BODY_SEL_BOX){
			Rectangle box=getBoxforCurrentSelection();
			int tmpX=(int)temp.getX()/CAVIARGUI.SCALE;
			int tmpY=(int)temp.getY()/CAVIARGUI.SCALE;
			if (box!=null){
				if (insideBoxCoordinates(tmpX,tmpY,box))
					point1 = new Point((int)(temp.getX()/2)*2,(int)(temp.getY()/2)*2); 	
				else{
					JOptionPane.showMessageDialog(null,("Initial coordinates for the body part must be inside the box"),
									  "Drawing Warning", JOptionPane.WARNING_MESSAGE);												
				}
			}else{
				JOptionPane.showMessageDialog(null,("It's not allowed to set a body part, the current selected box has not been drawn yet"),
								  "Drawing Warning", JOptionPane.WARNING_MESSAGE);					
			}
		}else{
			point1 = new Point((int)(temp.getX()/2)*2,(int)(temp.getY()/2)*2); 				
			if (isBodyforCurrentBoxSelectedEmpty()==false)
					JOptionPane.showMessageDialog(null,("Redrawing the box not allowed, body elements inside the box " +
														"\nreset body first to be able to edit this box"),
									  "Drawing Warning", JOptionPane.WARNING_MESSAGE);						
		}	    	
	}

	/** 
	 * Called when the mouse is pressed over the DrawCanvas object canvas,
	 * sets temp final point of rectangle.
	 */
	public void mouseDragged(MouseEvent e) {
		Point temp = e.getPoint();
		point2 = new Point((int)(temp.getX()/2)*2,(int)(temp.getY()/2)*2);
		if (bodyPartSelected==BODY_SEL_BOX){	    	
			drawRect();
		}else 
			drawBody(true);
	}
	
	/** 
	 * Called when the mouse is released over the DrawCanvas object canvas,
	 * sets final point of rectangle.
	 */
	public void mouseReleased(MouseEvent e) {

		Point temp = e.getPoint();
		point2 = new Point((int)(temp.getX()/2)*2,(int)(temp.getY()/2)*2);
		if (bodyPartSelected==BODY_SEL_BOX){
			drawRect();
			// box now drawn so must update variable
			int index = allData.frameData[id].getSelected();
	    
			if (index < FrameData.SINGLE_BOXES) {
			allData.frameData[id].singleBox[index].setBoxDrawn(true);
			} else {
			allData.frameData[id].groupBox[index-FrameData.SINGLE_BOXES].setBoxDrawn(true);
			}			
		}else{ 
			drawBody(false);
			}
		if (isASingleBoxSelected()) 		
			caviargui.resetIBDisplay();	
	}
	}
 
	private boolean bodyPartSelectedisRect(){
		if (bodyPartSelected==BODY_SEL_BOX)
			return true;
		else
			return false;	 
	}
	
	private boolean bodyPartSelectedisCircle(){
		if ((bodyPartSelected==BODY_SEL_HEAD) ||
			(bodyPartSelected==BODY_SEL_RIGHT_HAND) ||
			(bodyPartSelected==BODY_SEL_LEFT_HAND) ||
			(bodyPartSelected==BODY_SEL_RIGHT_FOOT) ||
			(bodyPartSelected==BODY_SEL_LEFT_FOOT)			
			)		
			return true;
		else
			return false;
	}
	
	private boolean bodyPartSelectedisLine(){
		if ((bodyPartSelected==BODY_SEL_RIGHT_SHOULDER) ||
			(bodyPartSelected==BODY_SEL_LEFT_SHOULDER))
			return true;
		else
			return false;		
	}
	
	public boolean bodySingleBoxisEmpty(){
		boolean empty=true;
		SingleBox single=getSingleBoxSelected();
		if (single!=null)
			empty=single.isBodyEmpty();
		return empty;
	}
    
    /** Action methods
     */
    // GREGOR

	//HUGO
	class supfitAction extends AbstractAction{
		public supfitAction(String name){
			super(name);
		}
		public void actionPerformed(ActionEvent e) {
			int selected = allData.frameData[id].getSelected();
			if(selected>=FrameData.SINGLE_BOXES){
				System.out.print(" GBx="+ (id+1));
				supfitActionPerformed(e);
				copyBoxNext();
				supfitActionPerformed(e);			
			}else
			{System.out.println("you have to select group-box");}
		}
	}
	//ENDHUGO	
	
	//jose
	
    class plusX1Action extends AbstractAction {
	public plusX1Action(String name) {
		super(name);
	}
	public void actionPerformed(ActionEvent e) {
		if (isBodyforCurrentBoxSelectedEmpty()==false)
				JOptionPane.showMessageDialog(null,("Redrawing the box not allowed, body elements inside the box " +
													"\nreset body first to be able to edit this box"),
								  "Drawing Warning", JOptionPane.WARNING_MESSAGE);
		else		
			plusX1ActionPerformed(e);
	}
    }
    class plusX2Action extends AbstractAction {
	public plusX2Action(String name) {
		super(name);
	}
	public void actionPerformed(ActionEvent e) {
		if (bodyPartSelected==BODY_SEL_BOX){
			if (isBodyforCurrentBoxSelectedEmpty()==false)
					JOptionPane.showMessageDialog(null,("Redrawing the box not allowed, body elements inside the box " +
														"\nreset body first to be able to edit this box"),
									  "Drawing Warning", JOptionPane.WARNING_MESSAGE);
			else		
				plusX2ActionPerformed(e);
		}else
			ArrowRightActionPerformed(e);
	}
    }
    class plusY1Action extends AbstractAction {
	public plusY1Action(String name) {
		super(name);
	}
	public void actionPerformed(ActionEvent e) {
		if (isBodyforCurrentBoxSelectedEmpty()==false)
				JOptionPane.showMessageDialog(null,("Redrawing the box not allowed, body elements inside the box " +
													"\nreset body first to be able to edit this box"),
								  "Drawing Warning", JOptionPane.WARNING_MESSAGE);
		else		
			plusY1ActionPerformed(e);
	}
    }
    class plusY2Action extends AbstractAction {
	public plusY2Action(String name) {
		super(name);
	}
	public void actionPerformed(ActionEvent e) {
		if (bodyPartSelected==BODY_SEL_BOX){
			if (isBodyforCurrentBoxSelectedEmpty()==false)
					JOptionPane.showMessageDialog(null,("Redrawing the box not allowed, body elements inside the box " +
														"\nreset body first to be able to edit this box"),
									  "Drawing Warning", JOptionPane.WARNING_MESSAGE);
			else		
				plusY2ActionPerformed(e);
		}else
			ArrowDownActionPerformed(e);
	}
    }
    class minusX1Action extends AbstractAction {
	public minusX1Action(String name) {
		super(name);
	}
	public void actionPerformed(ActionEvent e) {
		if (bodyPartSelected==BODY_SEL_BOX){
			if (isBodyforCurrentBoxSelectedEmpty()==false)
					JOptionPane.showMessageDialog(null,("Redrawing the box not allowed, body elements inside the box " +
														"\nreset body first to be able to edit this box"),
									  "Drawing Warning", JOptionPane.WARNING_MESSAGE);
			else		
				minusX1ActionPerformed(e);
		}else
			ArrowLeftActionPerformed(e);
	}
    }
    class minusX2Action extends AbstractAction {
	public minusX2Action(String name) {
		super(name);
	}
	public void actionPerformed(ActionEvent e) {
		if (isBodyforCurrentBoxSelectedEmpty()==false)
				JOptionPane.showMessageDialog(null,("Redrawing the box not allowed, body elements inside the box " +
													"\nreset body first to be able to edit this box"),
								  "Drawing Warning", JOptionPane.WARNING_MESSAGE);
		else		
			minusX2ActionPerformed(e);
	}
    }
    class minusY1Action extends AbstractAction {
	public minusY1Action(String name) {
		super(name);
	}
	public void actionPerformed(ActionEvent e) {
		if (bodyPartSelected==BODY_SEL_BOX){
			if (isBodyforCurrentBoxSelectedEmpty()==false)
					JOptionPane.showMessageDialog(null,("Redrawing the box not allowed, body elements inside the box " +
														"\nreset body first to be able to edit this box"),
									  "Drawing Warning", JOptionPane.WARNING_MESSAGE);
			else		
				minusY1ActionPerformed(e);
		}else
			ArrowUpActionPerformed(e);
	}
    }
    class minusY2Action extends AbstractAction {
	public minusY2Action(String name) {
		super(name);
	}
	public void actionPerformed(ActionEvent e) {
		if (isBodyforCurrentBoxSelectedEmpty()==false)
				JOptionPane.showMessageDialog(null,("Redrawing the box not allowed, body elements inside the box " +
													"\nreset body first to be able to edit this box"),
								  "Drawing Warning", JOptionPane.WARNING_MESSAGE);
		else		
			minusY2ActionPerformed(e);
	}
    }


    
    //END GREGOR

    /**
     * Calls public method loadInitialImage to create the new ImagePanel object.
     */
    public ImagePanel(String seq,CAVIARGUI caviargui) {
    	this.caviargui=caviargui;	
    	this.seqName=seq;
//	loadInitialImage();
    }

    /**
     * Calls public method loadInitialImage to create the new ImagePanel object.
     */
    public ImagePanel(CAVIARGUI caviargui) {
	this.caviargui=caviargui;	
	loadInitialImage();
	this.previd=id;
	this.prevselected=getSelected();
    }

    /**
     * Used by the constructor to set all variables to their default values.
     */
    public void loadInitialImage() {

	// Image name in jpgs directory
	
	fileName = "EnterExitCrossingPaths1cor0000.jpg";
	hundreds = false;

	// get sequence name from the fileName
	seqName = fileName.substring(0,(fileName.lastIndexOf('.')-4));
	
	// set up label for frame number and sequence name
	frameNumber = new JLabel();
		
	// get file id (last 3 numbers) from fileName
	id = Integer.parseInt(fileName.substring((fileName.lastIndexOf('.'))-4,(fileName.lastIndexOf('.'))));
	max = id;
	
	// load image file ...
	try {
	    // get file (all files stored in relavent JPEGS directory
	    imageFile = new File(seqName+"/JPEGS/"+fileName);
	    image = ImageIO.read(imageFile);
	    frameNumber.setText("Frame: "+ id + " in sequence " + seqName);
	} catch (IOException ioe) {
	    JOptionPane.showMessageDialog(null,("Unable to load: \n"+fileName),
					  "Load Error", JOptionPane.ERROR_MESSAGE);
	    frameNumber.setText("File not loaded");
	    ioe.printStackTrace();
	    frameNumber.setText("Default image jpgs/"+fileName+" failed to load");
	}
	
	// load image into canvas
	if (image != null) {
	    canvas = new DrawCanvas(image);
	} else {
	    canvas = new DrawCanvas();
	}
	
	canvas.setMinimumSize(new Dimension(384*2,288*2));
	canvas.setPreferredSize(new Dimension(384*2,288*2));

	allData.frameData[id] = new FrameData();
	
	// initialise data structure for representing frame and data	

	// add mouse listeners to panel, frame no label and canvas
	this.add(frameNumber);
	this.add(canvas);

	mouseListener = new IPanelMouseListener();
	canvas.addMouseListener(mouseListener);
	canvas.addMouseMotionListener(mouseListener);

	X1 = new JPanel();

	minusX1 = new JButton();  
	minusX1.setMinimumSize(new Dimension(45,25));
	minusX1.setPreferredSize(new Dimension(45,25));
	minusX1Action = new minusX1Action("L");
	minusX1.setAction(minusX1Action);
	minusX1.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke("LEFT"), "minusX1Action");
	minusX1.getActionMap().put("minusX1Action", minusX1Action);

	X1.add(minusX1);

	updateX1 = new JTextField();
	updateX1.setText("2");
	updateX1.setMinimumSize(new Dimension(30,25));
	updateX1.setPreferredSize(new Dimension(30,25));

	X1.add(updateX1);

	plusX1 = new JButton();
	plusX1.setMinimumSize(new Dimension(45,25));
	plusX1.setPreferredSize(new Dimension(45,25));
	plusX1Action = new plusX1Action("R");
	plusX1.setAction(plusX1Action);
	plusX1.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke("control LEFT"), "plusX1Action");
	plusX1.getActionMap().put("plusX1Action", plusX1Action);

	X1.add(plusX1);

	X2 = new JPanel(); 
	
	minusX2 = new JButton();
	minusX2.setMinimumSize(new Dimension(45,25));
	minusX2.setPreferredSize(new Dimension(45,25));
	minusX2Action = new minusX2Action("L");
	minusX2.setAction(minusX2Action);
	minusX2.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke("control RIGHT"), "minusX2Action");
	minusX2.getActionMap().put("minusX2Action", minusX2Action);

	X2.add(minusX2);

	updateX2 = new JTextField();
	updateX2.setText("2");
	updateX2.setMinimumSize(new Dimension(30,25));
	updateX2.setPreferredSize(new Dimension(30,25));
	
	X2.add(updateX2);

	plusX2 = new JButton();
	plusX2.setMinimumSize(new Dimension(45,25));
	plusX2.setPreferredSize(new Dimension(45,25));
	plusX2Action = new plusX2Action("R");
	plusX2.setAction(plusX2Action);
	plusX2.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke("RIGHT"), "plusX2Action");
	plusX2.getActionMap().put("plusX2Action", plusX2Action);


	X2.add(plusX2);

	alterY1 = new JPanel();

	Y1 = new JPanel(new BorderLayout());
		
	minusY1 = new JButton();

	minusY1.setMinimumSize(new Dimension(45,25));
	minusY1.setPreferredSize(new Dimension(45,25));
	minusY1Action = new minusY1Action("U");
	minusY1.setAction(minusY1Action);
	minusY1.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke("UP"), "minusY1Action");
	minusY1.getActionMap().put("minusY1Action", minusY1Action);

	Y1.add(minusY1,BorderLayout.NORTH);

	updateY1 = new JTextField();
	updateY1.setText("2");
	updateY1.setMinimumSize(new Dimension(30,25));
	updateY1.setPreferredSize(new Dimension(30,25));

	Y1.add(updateY1,BorderLayout.CENTER);

	
	plusY1 = new JButton();
	plusY1.setMinimumSize(new Dimension(45,25));
	plusY1.setPreferredSize(new Dimension(45,25));
	plusY1Action = new plusY1Action("D");
	plusY1.setAction(plusY1Action);
	plusY1.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke("control UP"), "plusY1Action");
	plusY1.getActionMap().put("plusY1Action", plusY1Action);

	Y1.add(plusY1,BorderLayout.SOUTH);

	alterY1.add(Y1);

	alterY2 = new JPanel();

	Y2 = new JPanel(new BorderLayout());
	
	minusY2 = new JButton();
	minusY2.setMinimumSize(new Dimension(45,25));
	minusY2.setPreferredSize(new Dimension(45,25));
	minusY2Action = new minusY2Action("U");
	minusY2.setAction(minusY2Action);
	minusY2.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke("control DOWN"), "minusY2Action");
	minusY2.getActionMap().put("minusY2Action", minusY2Action);

	Y2.add(minusY2,BorderLayout.NORTH);

	updateY2 = new JTextField();
	updateY2.setText("2");
	updateY2.setMinimumSize(new Dimension(30,25));
	updateY2.setPreferredSize(new Dimension(30,25));
	
	Y2.add(updateY2,BorderLayout.CENTER);

	plusY2 = new JButton();
	plusY2.setMinimumSize(new Dimension(45,25));
	plusY2.setPreferredSize(new Dimension(45,25));
	plusY2Action = new plusY2Action("D");
	plusY2.setAction(plusY2Action);
	plusY2.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke("DOWN"), "plusY2Action");
	plusY2.getActionMap().put("plusY2Action", plusY2Action);

	Y2.add(plusY2,BorderLayout.SOUTH);

	alterY2.add(Y2);

	box = new JButton();
	box.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
			supfitActionPerformed(evt);
		}
		});
	supfitAction = new supfitAction("W");
	box.setAction(supfitAction);
	box.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke('w'), "supfitAction");
	box.getActionMap().put("supfitAction", supfitAction);	
		
	
	box.setText("AD GB");	
	
	alterX = new JPanel(new BorderLayout());
	alterX.add(X1,BorderLayout.WEST);
	alterX.add(X2,BorderLayout.EAST);
	alterX.add(box,BorderLayout.CENTER);
	
	alterY1.add(Y1,BorderLayout.NORTH);
	alterY2.add(Y2,BorderLayout.SOUTH);

	alterDimensions = new JPanel(new BorderLayout());

	alterDimensions.add(alterY1,BorderLayout.NORTH);
	alterDimensions.add(alterX,BorderLayout.CENTER);
	alterDimensions.add(alterY2,BorderLayout.SOUTH);
	
	alterBody = new JPanel();
	
	bodycanvas = new BodyCanvas();
	bodycanvas.setSize(200,300);
	
	
//	alterBody.add(bodycanvas);
	
	alterControls= new JPanel();
	alterControls.setLayout(new GridBagLayout());
	GridBagConstraints c = new GridBagConstraints();
	c.fill = GridBagConstraints.HORIZONTAL;

	c.gridx=0;c.gridy=0;c.gridwidth=1;c.gridheight=1;
	alterControls.add(alterDimensions,c);
	
	c.gridx=1;c.gridy=0;c.gridwidth=1;c.gridheight=1;
	alterControls.add(alterBody,c);	
	
	this.add(alterControls);
	this.previd=id;
	this.prevselected=getSelected();	
    }
    
    private void plusX1ActionPerformed(ActionEvent evt) {
	int selected = allData.frameData[id].getSelected();
	Rectangle newBox = new Rectangle();

	try {
	     int update = Integer.parseInt(updateX1.getText());

	     if (Math.ceil((double)update/CAVIARGUI.SCALE) != Math.floor((double)update/CAVIARGUI.SCALE)) {
		 JOptionPane.showMessageDialog(null,
					       ("Must enter a multiple of 2 as image\n"+
						"is double scale"),
					       "Input Error", JOptionPane.WARNING_MESSAGE);
	    } else {

		if (selected < FrameData.SINGLE_BOXES) {
		    if (allData.frameData[id].singleBox[selected].getBoxDrawn()) {
			// box drawn so alter dimensions
			newBox = allData.frameData[id].singleBox[selected].getBox();
			int newX = ((int)newBox.getX()*CAVIARGUI.SCALE)+update;
			int Y = ((int)newBox.getY()*CAVIARGUI.SCALE);
			int newWidth = ((int)newBox.getWidth()*CAVIARGUI.SCALE)-update;
			int Height = ((int)newBox.getHeight()*CAVIARGUI.SCALE);
			if (newWidth > 0) {
			    point1 = new Point(newX,Y);
			    point2 = new Point(newX+newWidth,Y+Height);
			    drawRect();
			}
		    }
		} else { 
		    if (allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBoxDrawn()) {
			// box drawn so alter dimensions
			newBox = allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBox();
			int newX = ((int)newBox.getX()*CAVIARGUI.SCALE)+update;
			int Y = ((int)newBox.getY()*CAVIARGUI.SCALE);
			int newWidth = ((int)newBox.getWidth()*CAVIARGUI.SCALE)-update;
			int Height = ((int)newBox.getHeight()*CAVIARGUI.SCALE);
			if (newWidth > 0) {
			    point1 = new Point(newX,Y);
			    point2 = new Point(newX+newWidth,Y+Height);
			    drawRect();
			}
		    }
		}
	    }
	} catch (NumberFormatException nfe) {
	    JOptionPane.showMessageDialog(X1, ("Must be a number entered in text field"),
					  "Numeric Error", JOptionPane.ERROR_MESSAGE);
	}
    }

	private void ArrowUpActionPerformed(ActionEvent evt){
//		System.out.println("Hitting key Up ");	
		if (bodyPartSelectedisDraw()){
			if (bodyPartSelectedisCircle()){
				int r=(int)(Math.sqrt(Math.pow(point1.getX()-point2.getX(),2)+Math.pow(point1.getY()-point2.getY(),2)));
				this.point1=new Point((int)point1.getX(),(int)(point1.getY()-DELTA*CAVIARGUI.SCALE));
				this.point2=new Point((int)point1.getX(),(int)(point1.getY()-r));			
				drawBody(false);	
			}
			if (bodyPartSelectedisLine()){
				this.point1=new Point((int)point1.getX(),(int)(point1.getY()-DELTA*CAVIARGUI.SCALE));
				this.point2=new Point((int)point2.getX(),(int)(point2.getY()));
				drawBody(false);
			}
		}else{
			JOptionPane.showMessageDialog(X1, ("Current body part selected has not been draw yet"),
						  "Body Part Error", JOptionPane.ERROR_MESSAGE);			
		}
	}
	private void ArrowDownActionPerformed(ActionEvent evt){
//		System.out.println("Hitting key down ");
		if (bodyPartSelectedisDraw()){			
			if (bodyPartSelectedisCircle()){
				int r=(int)(Math.sqrt(Math.pow(point1.getX()-point2.getX(),2)+Math.pow(point1.getY()-point2.getY(),2)));
				this.point1=new Point((int)point1.getX(),(int)(point1.getY()+DELTA*CAVIARGUI.SCALE));
				this.point2=new Point((int)point1.getX(),(int)(point1.getY()-r));			
				drawBody(false);	
			}	
			if (bodyPartSelectedisLine()){
				this.point1=new Point((int)point1.getX(),(int)(point1.getY()+DELTA*CAVIARGUI.SCALE));
				this.point2=new Point((int)point2.getX(),(int)(point2.getY()));
				drawBody(false);
			}
		}else{
			JOptionPane.showMessageDialog(X1, ("Current body part selected has not been draw yet"),
						  "Body Part Error", JOptionPane.ERROR_MESSAGE);			
		}	
	}	
	private void ArrowRightActionPerformed(ActionEvent evt){
//		System.out.println("Hitting key right ");	
		if (bodyPartSelectedisDraw()){			
			if (bodyPartSelectedisCircle()){
				int r=(int)(Math.sqrt(Math.pow(point1.getX()-point2.getX(),2)+Math.pow(point1.getY()-point2.getY(),2)));
				this.point1=new Point((int)(point1.getX()+DELTA*CAVIARGUI.SCALE),(int)point1.getY());
				this.point2=new Point((int)(point1.getX()+r),(int)point1.getY());			
				drawBody(false);	
			}	
			if (bodyPartSelectedisLine()){
				this.point1=new Point((int)(point1.getX()+DELTA*CAVIARGUI.SCALE),(int)point1.getY());
				this.point2=new Point((int)point2.getX(),(int)(point2.getY()));
				drawBody(false);
			}
		}else{
			JOptionPane.showMessageDialog(X1, ("Current body part selected has not been draw yet"),
						  "Body Part Error", JOptionPane.ERROR_MESSAGE);			
		}				
	}	
	private void ArrowLeftActionPerformed(ActionEvent evt){
//		System.out.println("Hitting key left ");	
		if (bodyPartSelectedisDraw()){			
			if (bodyPartSelectedisCircle()){
				int r=(int)(Math.sqrt(Math.pow(point1.getX()-point2.getX(),2)+Math.pow(point1.getY()-point2.getY(),2)));
				this.point1=new Point((int)(point1.getX()-DELTA*CAVIARGUI.SCALE),(int)point1.getY());
				this.point2=new Point((int)(point1.getX()-r),(int)point1.getY());			
				drawBody(false);	
			}
			if (bodyPartSelectedisLine()){
				this.point1=new Point((int)(point1.getX()-DELTA*CAVIARGUI.SCALE),(int)point1.getY());
				this.point2=new Point((int)point2.getX(),(int)(point2.getY()));
				drawBody(false);
			}	
		}else{
			JOptionPane.showMessageDialog(X1, ("Current body part selected has not been draw yet"),
						  "Body Part Error", JOptionPane.ERROR_MESSAGE);			
		}					
	}			
    
	public void Key1ActionPerformed(ActionEvent evt){
		this.bodyPartSelected=BODY_SEL_BOX;		
		int index=getSelected();
		if (index < FrameData.SINGLE_BOXES) {	
			singleBoxUpdateDisplay(index);	
		}else{
			JOptionPane.showMessageDialog(null,
							  ("Current box selected is the group box"),
							  "WARNING", JOptionPane.WARNING_MESSAGE);			
		}
		
	}

	public void switchBodyPart(int i,SingleBox single){
		if (single!=null) {
			updateBodyPartSelected(i,single);		
		}else{
			JOptionPane.showMessageDialog(null,
							  ("Current box selected is either not drawn or is a group box"),
							  "WARNING", JOptionPane.WARNING_MESSAGE);			
		}		
	}

	public void Key2ActionPerformed(ActionEvent evt){
		SingleBox single=getSingleBoxSelected();
		switchBodyPart(ImagePanel.BODY_SEL_HEAD,single);
	}

	public void Key3ActionPerformed(ActionEvent evt){
		SingleBox single=getSingleBoxSelected();
		switchBodyPart(ImagePanel.BODY_SEL_GAZE,single);	
	}

	public void Key4ActionPerformed(ActionEvent evt){
		SingleBox single=getSingleBoxSelected();
		switchBodyPart(ImagePanel.BODY_SEL_RIGHT_SHOULDER,single);		
	}
	
	public void Key5ActionPerformed(ActionEvent evt){
		SingleBox single=getSingleBoxSelected();
		switchBodyPart(ImagePanel.BODY_SEL_LEFT_SHOULDER,single);	
	}
	
	public void Key6ActionPerformed(ActionEvent evt){
		SingleBox single=getSingleBoxSelected();
		switchBodyPart(ImagePanel.BODY_SEL_RIGHT_HAND,single);		
	}	
	
	public void Key7ActionPerformed(ActionEvent evt){
		SingleBox single=getSingleBoxSelected();
		switchBodyPart(ImagePanel.BODY_SEL_LEFT_HAND,single);		
	}
	
	public void Key8ActionPerformed(ActionEvent evt){
		SingleBox single=getSingleBoxSelected();
		switchBodyPart(ImagePanel.BODY_SEL_RIGHT_FOOT,single);			
	}	

	public void Key9ActionPerformed(ActionEvent evt){
		SingleBox single=getSingleBoxSelected();
		switchBodyPart(ImagePanel.BODY_SEL_LEFT_FOOT,single);			
	}
	public void KeyDActionPerformed(ActionEvent evt){
		if (bodyPartSelected!=BODY_SEL_BOX){
			this.point1=null;this.point2=null;
			if ((bodyPartSelected==BODY_SEL_GAZE) || (bodyPartSelected==BODY_SEL_HEAD)){
				SingleBox single=getSingleBoxSelected();
				Body b=single.getBody();
				b.setGaze(-1);
			}				
			drawBody(false);		
		}else{
			JOptionPane.showMessageDialog(null,
							  ("Use Delete Box Button to delete the box"),
							  "WARNING", JOptionPane.WARNING_MESSAGE);				
		}
	}	
	public void KeyEActionPerformed(ActionEvent evt){
//		System.out.println("Hitting key E ");
		copyBodyNext();		
	}	

	
	public int KeyZActionPerformed(ActionEvent evt){
		int index=getbodyPartSelected();
		index++;
		if (index>BODY_SEL_LEFT_FOOT)
			index=1;
		if (isASingleBoxSelected()){
			SingleBox single=getSingleBoxSelected();
			if (single.getBoxDrawn()){
			}
			else{
			index=1;
			JOptionPane.showMessageDialog(this,
							  ("Box not drawn, first draw the bounding box"),
							  "WARNING", JOptionPane.WARNING_MESSAGE);
			}			
			
		}else{
			JOptionPane.showMessageDialog(this,
							  ("Group box selected"),
							  "WARNING", JOptionPane.WARNING_MESSAGE);						
		}	
		return index;	
	}	
	
	public void KeyAActionPerformed(ActionEvent evt,int inc){
//		System.out.println("Hitting key A ");
		if (bodyPartSelectedisCircle())
			updateRatioforSelectedCircle(-inc);	
		if (this.bodyPartSelected==BODY_SEL_GAZE)
			updateGaze(-inc);	
	}
	public void KeySActionPerformed(ActionEvent evt,int inc){
//		System.out.println("Hitting key S ");
		if (bodyPartSelectedisCircle())
			updateRatioforSelectedCircle(inc);
		if (this.bodyPartSelected==BODY_SEL_GAZE)
			updateGaze(inc);				
	}
	public boolean KeyXActionPerformed(ActionEvent evt){
		boolean deleted=false;
		if (isASingleBoxSelected()){
			Body body=new Body();	
			SingleBox single=getSingleBoxSelected();
			if (single!=null){
				int confirm = JOptionPane.showConfirmDialog(this,"Are you sure you would like to delete\n"+
									"the body from the annotation?",
									"Delete Body?", JOptionPane.YES_NO_OPTION);
				if (confirm == 0) {
					single.setBody(body);
					updateBodyPartSelected(BODY_SEL_BOX,single);
					deleted=true;
				}							
			}
		}else{
			JOptionPane.showMessageDialog(this,
							  ("Current box selected is a group box"),
							  "WARNING", JOptionPane.WARNING_MESSAGE);					
		}
		return deleted;
	}
	
	public void KeyCActionPerformed(ActionEvent evt){
	
	}
	    
	public void setShowCurrentSelectionTags() {
		canvas.setShowCurrentSelectionTags();
	}

	public void setShowAllBodyBoxes() {
		canvas.setShowAllBodyBoxes();
	}

	public void setShowAllBodyTags() {
		canvas.setShowAllBodyTags();
	}
	
	public void setBoxNames(){
		canvas.setBoxNames();
	}
	    
//HUGO
//***************************************************************************************
	private void supfitActionPerformed(ActionEvent evt){
		int selected = allData.frameData[id].getSelected();
		int x1=0, x2=0, y1=0, y2=0;
		int minx = 9999, maxx = -9999, miny = 9999, maxy = -9999;
		Rectangle newBox = new Rectangle();	

		for (int i=0;i<FrameData.SINGLE_BOXES;i++){
			if (allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].indBoxes[i]){
				newBox = allData.frameData[id].singleBox[i].getBox();
				x1 = (int)newBox.getX();
				y1 = (int)newBox.getY();
				x2 = x1+(int)newBox.getWidth();
				y2 = y1+(int)newBox.getHeight();
				if (x1<minx) minx = x1;
				if (x2>maxx) maxx = x2;
				if (y1<miny) miny = y1;
				if (y2>maxy) maxy = y2;
				//System.out.println(x1+" "+y1+" "+x2+" "+y2);
			}
		}
		point1 = new Point(2*minx,2*miny);
		point2 = new Point(2*maxx,2*maxy);
		drawRect();
	}
//ENDHUGO


    private void minusX1ActionPerformed(ActionEvent evt) {
	int selected = allData.frameData[id].getSelected();
	Rectangle newBox = new Rectangle();	

	try {
	    int update = Integer.parseInt(updateX1.getText());
	    
	    if (Math.ceil((double)update/CAVIARGUI.SCALE) != Math.floor((double)update/CAVIARGUI.SCALE)) {
		JOptionPane.showMessageDialog(null,
					      ("Must enter a multiple of 2 as image\n"+
					       "is double scale"),
					      "Input Error", JOptionPane.WARNING_MESSAGE);
	    } else {

		if (selected < FrameData.SINGLE_BOXES) {
		    
		    if (allData.frameData[id].singleBox[selected].getBoxDrawn()) {
			// box drawn so alter dimensions
			newBox = allData.frameData[id].singleBox[selected].getBox();
			int newX = ((int)newBox.getX()*CAVIARGUI.SCALE)-update;
			int Y = ((int)newBox.getY()*CAVIARGUI.SCALE);
			int newWidth = ((int)newBox.getWidth()*CAVIARGUI.SCALE)+update;
			int Height = ((int)newBox.getHeight()*CAVIARGUI.SCALE);
			if (newX >= 0) {
			    point1 = new Point(newX,Y);
			    point2 = new Point(newX+newWidth,Y+Height);
			    drawRect();
			}
		    }
		} else { 
		    if (allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBoxDrawn()) {
			// box drawn so alter dimensions
			newBox = allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBox();
			int newX = ((int)newBox.getX()*CAVIARGUI.SCALE)-update;
			int Y = ((int)newBox.getY()*CAVIARGUI.SCALE);
			int newWidth = ((int)newBox.getWidth()*CAVIARGUI.SCALE)+update;
			int Height = ((int)newBox.getHeight()*CAVIARGUI.SCALE);
			if (newX >= 0) {
			    point1 = new Point(newX,Y);
			    point2 = new Point(newX+newWidth,Y+Height);
			    drawRect();
			}
		    }
		}
	    }
	} catch (NumberFormatException nfe) {
	    JOptionPane.showMessageDialog(X1, ("Must be a number entered in text field"),
					  "Numeric Error", JOptionPane.ERROR_MESSAGE);
	}
    }

    private void plusX2ActionPerformed(ActionEvent evt) {
  	int selected = allData.frameData[id].getSelected();
	Rectangle newBox = new Rectangle();	
	
	try {
	    int update = Integer.parseInt(updateX2.getText());
	    
	    if (Math.ceil((double)update/CAVIARGUI.SCALE) != Math.floor((double)update/CAVIARGUI.SCALE)) {
		JOptionPane.showMessageDialog(null,
					      ("Must enter a multiple of 2 as image\n"+
					       "is double scale"),
					      "Input Error", JOptionPane.WARNING_MESSAGE);
	    } else {
		
		if (selected < FrameData.SINGLE_BOXES) {
		    
		    if (allData.frameData[id].singleBox[selected].getBoxDrawn()) {
			// box drawn so alter dimensions
			newBox = allData.frameData[id].singleBox[selected].getBox();
			int X = ((int)newBox.getX()*CAVIARGUI.SCALE);
			int Y = ((int)newBox.getY()*CAVIARGUI.SCALE);
			int newWidth = ((int)newBox.getWidth()*CAVIARGUI.SCALE)+update;
			int Height = ((int)newBox.getHeight()*CAVIARGUI.SCALE);
			if (X+newWidth < canvas.imageWidth) {
			    point1 = new Point(X,Y);
			    point2 = new Point(X+newWidth,Y+Height);
			    drawRect();
			}
		    }
		} else { 
		    if (allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBoxDrawn()) {
			// box drawn so alter dimensions
			newBox = allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBox();
			int X = ((int)newBox.getX()*CAVIARGUI.SCALE);
			int Y = ((int)newBox.getY()*CAVIARGUI.SCALE);
			int newWidth = ((int)newBox.getWidth()*CAVIARGUI.SCALE)+update;
			int Height = ((int)newBox.getHeight()*CAVIARGUI.SCALE);
			if (X+newWidth < canvas.imageWidth) {
			    point1 = new Point(X,Y);
			    point2 = new Point(X+newWidth,Y+Height);
			    drawRect();
			}
		    }
		}
	    }
	} catch (NumberFormatException nfe) {
	    JOptionPane.showMessageDialog(X2, ("Must be a number entered in text field"),
					  "Numeric Error", JOptionPane.ERROR_MESSAGE);
	}
    }

    private void minusX2ActionPerformed(ActionEvent evt) {
	int selected = allData.frameData[id].getSelected();
	Rectangle newBox = new Rectangle();	

	try {
	    int update = Integer.parseInt(updateX2.getText());

	    
	    if (Math.ceil((double)update/CAVIARGUI.SCALE) != Math.floor((double)update/CAVIARGUI.SCALE)) {
		JOptionPane.showMessageDialog(null,
					      ("Must enter a multiple of 2 as image\n"+
					       "is double scale"),
					      "Input Error", JOptionPane.WARNING_MESSAGE);
	    } else {
		
		if (selected < FrameData.SINGLE_BOXES) {
		    
		    if (allData.frameData[id].singleBox[selected].getBoxDrawn()) {
			// box drawn so alter dimensions
			newBox = allData.frameData[id].singleBox[selected].getBox();
			int X = ((int)newBox.getX()*CAVIARGUI.SCALE);
			int Y = ((int)newBox.getY()*CAVIARGUI.SCALE);
			int newWidth = ((int)newBox.getWidth()*CAVIARGUI.SCALE)-update;
			int Height = ((int)newBox.getHeight()*CAVIARGUI.SCALE);
			if (newWidth > 0) {
			    point1 = new Point(X,Y);
			    point2 = new Point(X+newWidth,Y+Height);
			    drawRect();
			}
		    }
		} else { 
		    if (allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBoxDrawn()) {
			// box drawn so alter dimensions
			newBox = allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBox();
			int X = ((int)newBox.getX()*CAVIARGUI.SCALE);
			int Y = ((int)newBox.getY()*CAVIARGUI.SCALE);
			int newWidth = ((int)newBox.getWidth()*CAVIARGUI.SCALE)-update;
			int Height = ((int)newBox.getHeight()*CAVIARGUI.SCALE);
			if (newWidth > 0) {
			    point1 = new Point(X,Y);
			    point2 = new Point(X+newWidth,Y+Height);
			    drawRect();
			}
		    }
		}
	    }
	    
	} catch (NumberFormatException nfe) {
	    JOptionPane.showMessageDialog(X2, ("Must be a number entered in text field"),
					  "Numeric Error", JOptionPane.ERROR_MESSAGE);
	}
    }
    
    private void plusY1ActionPerformed(ActionEvent evt) {
	int selected = allData.frameData[id].getSelected();
	Rectangle newBox = new Rectangle();	

	try {
	    int update = Integer.parseInt(updateY1.getText());
	    
	    if (Math.ceil((double)update/CAVIARGUI.SCALE) != Math.floor((double)update/CAVIARGUI.SCALE)) {
		JOptionPane.showMessageDialog(null,
					      ("Must enter a multiple of 2 as image\n"+
					       "is double scale"),
					      "Input Error", JOptionPane.WARNING_MESSAGE);
	    } else {

		if (selected < FrameData.SINGLE_BOXES) {
		    
		    if (allData.frameData[id].singleBox[selected].getBoxDrawn()) {
			// box drawn so alter dimensions
			newBox = allData.frameData[id].singleBox[selected].getBox();
			int X = ((int)newBox.getX()*CAVIARGUI.SCALE);
			int newY = ((int)newBox.getY()*CAVIARGUI.SCALE)+update;
			int Width = ((int)newBox.getWidth()*CAVIARGUI.SCALE);
			int newHeight = ((int)newBox.getHeight()*CAVIARGUI.SCALE)-update;
			if (newHeight > 0 && newY+newHeight < canvas.imageHeight) {
			    point1 = new Point(X,newY);
			    point2 = new Point(X+Width,newY+newHeight);
			    drawRect();
			}
		    }
		} else { 
		    if (allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBoxDrawn()) {
			// box drawn so alter dimensions
			newBox = allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBox();
			int X = ((int)newBox.getX()*CAVIARGUI.SCALE);
			int newY = ((int)newBox.getY()*CAVIARGUI.SCALE)+update;
			int Width = ((int)newBox.getWidth()*CAVIARGUI.SCALE);
			int newHeight = ((int)newBox.getHeight()*CAVIARGUI.SCALE)-update;
			if (newHeight > 0 && newY+newHeight < canvas.imageHeight) {
			    point1 = new Point(X,newY);
			    point2 = new Point(X+Width,newY+newHeight);
			    drawRect();
			}
		    }
		}
	    }
	} catch (NumberFormatException nfe) {
	    JOptionPane.showMessageDialog(Y1, ("Must be a number entered in text field"),
					  "Numeric Error", JOptionPane.ERROR_MESSAGE);
	}
    }

    private void minusY1ActionPerformed(ActionEvent evt) {
	int selected = allData.frameData[id].getSelected();
	Rectangle newBox = new Rectangle();	

	try {
	    int update = Integer.parseInt(updateY1.getText());
	    
	    if (Math.ceil((double)update/CAVIARGUI.SCALE) != Math.floor((double)update/CAVIARGUI.SCALE)) {
		JOptionPane.showMessageDialog(null,
					      ("Must enter a multiple of 2 as image\n"+
					       "is double scale"),
					      "Input Error", JOptionPane.WARNING_MESSAGE);
	    } else {
		
		if (selected < FrameData.SINGLE_BOXES) {
		    
		    if (allData.frameData[id].singleBox[selected].getBoxDrawn()) {
			// box drawn so alter dimensions
			newBox = allData.frameData[id].singleBox[selected].getBox();
			int X = ((int)newBox.getX()*CAVIARGUI.SCALE);
			int newY = ((int)newBox.getY()*CAVIARGUI.SCALE)-update;
			int Width = ((int)newBox.getWidth()*CAVIARGUI.SCALE);
			int newHeight = ((int)newBox.getHeight()*CAVIARGUI.SCALE)+update;
			if (newY >= 0) {
			    point1 = new Point(X,newY);
			    point2 = new Point(X+Width,newY+newHeight);
			    drawRect();
			}
		    }
		} else { 
		    if (allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBoxDrawn()) {
			// box drawn so alter dimensions
			newBox = allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBox();
			int X = ((int)newBox.getX()*CAVIARGUI.SCALE);
			int newY = ((int)newBox.getY()*CAVIARGUI.SCALE)-update;
			int Width = ((int)newBox.getWidth()*CAVIARGUI.SCALE);
			int newHeight = ((int)newBox.getHeight()*CAVIARGUI.SCALE)+update;
			if (newY >= 0) {
			    point1 = new Point(X,newY);
			    point2 = new Point(X+Width,newY+newHeight);
			    drawRect();
			}
		    }
		}
	    }
	} catch (NumberFormatException nfe) {
	    JOptionPane.showMessageDialog(Y1, ("Must be a number entered in text field"),
					  "Numeric Error", JOptionPane.ERROR_MESSAGE);
	}
    }
    
    private void plusY2ActionPerformed(ActionEvent evt) {
//		System.out.println("pressing down arrow");    	
	int selected = allData.frameData[id].getSelected();
	Rectangle newBox = new Rectangle();	


	try {
	    int update = Integer.parseInt(updateY2.getText());
	
	    if (Math.ceil((double)update/CAVIARGUI.SCALE) != Math.floor((double)update/CAVIARGUI.SCALE)) {
		JOptionPane.showMessageDialog(null,
					      ("Must enter a multiple of 2 as image\n"+
					       "is double scale"),
					      "Input Error", JOptionPane.WARNING_MESSAGE);
	    } else {
		
		if (selected < FrameData.SINGLE_BOXES) {
		    
		    if (allData.frameData[id].singleBox[selected].getBoxDrawn()) {
			// box drawn so alter dimensions
			newBox = allData.frameData[id].singleBox[selected].getBox();
			int X = ((int)newBox.getX()*CAVIARGUI.SCALE);
			int Y = ((int)newBox.getY()*CAVIARGUI.SCALE);
			int Width = ((int)newBox.getWidth()*CAVIARGUI.SCALE);
			int newHeight = ((int)newBox.getHeight()*CAVIARGUI.SCALE)+update;
			if (Y+newHeight < canvas.imageHeight) {
			    point1 = new Point(X,Y);
			    point2 = new Point(X+Width,Y+newHeight);
			    drawRect();
			}
		    }
		} else { 
		    if (allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBoxDrawn()) {
			// box drawn so alter dimensions
			newBox = allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBox();
			int X = ((int)newBox.getX()*CAVIARGUI.SCALE);
			int Y = ((int)newBox.getY()*CAVIARGUI.SCALE);
			int Width = ((int)newBox.getWidth()*CAVIARGUI.SCALE);
			int newHeight = ((int)newBox.getHeight()*CAVIARGUI.SCALE)+update;
			if (Y+newHeight < canvas.imageHeight) {
			    point1 = new Point(X,Y);
			    point2 = new Point(X+Width,Y+newHeight);
			    drawRect();
			}
		    }
		}
	    }
	} catch (NumberFormatException nfe) {
	    JOptionPane.showMessageDialog(Y2, ("Must be a number entered in text field"),
					  "Numeric Error", JOptionPane.ERROR_MESSAGE);
	}
    }

    private void minusY2ActionPerformed(ActionEvent evt) {
	int selected = allData.frameData[id].getSelected();
	Rectangle newBox = new Rectangle();	

	try {
	    int update = Integer.parseInt(updateY2.getText());
	
	    
	    if (Math.ceil((double)update/CAVIARGUI.SCALE) != Math.floor((double)update/CAVIARGUI.SCALE)) {
		JOptionPane.showMessageDialog(null,
					      ("Must enter a multiple of 2 as image\n"+
					       "is double scale"),
					      "Input Error", JOptionPane.WARNING_MESSAGE);
	    } else {
		
		if (selected < FrameData.SINGLE_BOXES) {
		    
		    if (allData.frameData[id].singleBox[selected].getBoxDrawn()) {
			// box drawn so alter dimensions
			newBox = allData.frameData[id].singleBox[selected].getBox();
			int X = ((int)newBox.getX()*CAVIARGUI.SCALE);
			int Y = ((int)newBox.getY()*CAVIARGUI.SCALE);
			int Width = ((int)newBox.getWidth()*CAVIARGUI.SCALE);
			int newHeight = ((int)newBox.getHeight()*CAVIARGUI.SCALE)-update;
			if (newHeight > 0) {
			    point1 = new Point(X,Y);
			    point2 = new Point(X+Width,Y+newHeight);
			    drawRect();
			}
		    }
		} else { 
		    if (allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBoxDrawn()) {
			// box drawn so alter dimensions
			newBox = allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBox();
			int X = ((int)newBox.getX()*CAVIARGUI.SCALE);
			int Y = ((int)newBox.getY()*CAVIARGUI.SCALE);
			int Width = ((int)newBox.getWidth()*CAVIARGUI.SCALE);
			int newHeight = ((int)newBox.getHeight()*CAVIARGUI.SCALE)-update;
			if (newHeight > 0) {
			    point1 = new Point(X,Y);
			    point2 = new Point(X+Width,Y+newHeight);
			drawRect();
			}
		    }
		}
	    }
	} catch (NumberFormatException nfe) {
	    JOptionPane.showMessageDialog(Y2, ("Must be a number entered in text field"),
					  "Numeric Error", JOptionPane.ERROR_MESSAGE);
	}
    }
    
    /** 
     * Method used so that CAVIARGUI can find out which box has been
     * selected without needing the knowledge of which frame has been
     * loaded.
     */
    public int getSelected() {
	if (allData != null) {
	    return allData.frameData[id].getSelected();
	} else {
	    return 0; // default 0 selected
	}
    }

    /** 
     * Used to update display so that currently selected box is in red.
     */
    
    
    public void singleBoxUpdateDisplay(int index) {
//   	System.out.println("this index is "+index+" prevselected was "+prevselected+" id "+id+" previd "+previd);
  	if ((index!=prevselected) || (previd!=id)){
    		this.bodyPartSelected=1;
    	}
    this.previd=id;
    this.prevselected=index;
	
	LinkedList returnList = new LinkedList();
	if (allData.frameData[id].singleBox[index].getBoxDrawn() == true) {
	    Rectangle r = allData.frameData[id].singleBox[index].getBox();
	    //System.out.println(r);
	    //System.out.println(allData.frameData[id].singleBox[index].getSelected());
	    returnList = canvas.drawBox(new Point((int)r.getX()*CAVIARGUI.SCALE,
						  (int)r.getY()*CAVIARGUI.SCALE), 
					new Point(((int)r.getX()+(int)r.getWidth())*CAVIARGUI.SCALE,
						  ((int)r.getY()+(int)r.getHeight())*CAVIARGUI.SCALE),
					allData.frameData[id]);
	    // must have a box drawn in 
	    if (returnList.size() == 2) {
		Line2D.Float temp = (Line2D.Float) returnList.removeLast();
		allData.frameData[id].singleBox[index].setLine(new Line2D.Float((float)(temp.getX1()/CAVIARGUI.SCALE),
										(float)(temp.getY1()/CAVIARGUI.SCALE),
										(float)(temp.getX2()/CAVIARGUI.SCALE),
										(float)(temp.getY2()/CAVIARGUI.SCALE)));
	    }
	} else {
	    returnList = canvas.drawBox(new Point(0,0),
			   new Point(0,0),
			   allData.frameData[id]);
	}
    }
    
	/** 
	 * Used to update display so that currently selected box is in red.
	 */
	public void groupBoxUpdateDisplay(int index) {
	LinkedList returnList = new LinkedList();
	if (allData.frameData[id].groupBox[index].getBoxDrawn() == true) {
		Rectangle r = allData.frameData[id].groupBox[index].getBox();
		returnList = canvas.drawBox(new Point((int)r.getX()*CAVIARGUI.SCALE,
						  (int)r.getY()*CAVIARGUI.SCALE), 
					new Point(((int)r.getX()+(int)r.getWidth())*CAVIARGUI.SCALE,
						  ((int)r.getY()+(int)r.getHeight())*CAVIARGUI.SCALE),
					allData.frameData[id]);
		if (returnList.size() == 2) {
		Line2D.Float temp = (Line2D.Float) returnList.removeLast();
		allData.frameData[id].groupBox[index].setLine(new Line2D.Float((float)(temp.getX1()/CAVIARGUI.SCALE),
										(float)(temp.getY1()/CAVIARGUI.SCALE),
										(float)(temp.getX2()/CAVIARGUI.SCALE),
										(float)(temp.getY2()/CAVIARGUI.SCALE)));
		}
	} else {
		canvas.drawBox(new Point(0,0),
			   new Point(0,0),
			   allData.frameData[id]);
	}
	}    



    /**
     * Deletes the SingleBox object at index selected .
     */
    public void deleteIndBox(int selected) {
	allData.frameData[id].singleBox[selected] = new SingleBox();
	setSingleSelected(selected);
    }

    /** 
     * Gets the rectangle object representing the box for SingleBox number selected
     */
    public Rectangle getSingleBox(int selected) {
	return allData.frameData[id].singleBox[selected].getBox();
    }

    /**
     * Sets the SingleBox object at index selected axis attribute to update.
     */
    public void setIBAxis(int selected, int update) {
	allData.frameData[id].singleBox[selected].setAxis(update);
	singleBoxUpdateDisplay(selected);
    }

    /**
     * Returns the SingleBox object at index selected axis attribute.
     */
    public int getIBAxis(int selected) {
	return allData.frameData[id].singleBox[selected].getAxis();
    }

    /**
     * Toggles the appear truth value of the SingleBox object at index selected,
     * updates disappear and occluded appropriately.
     */
    public boolean setIBAppear(int selected) {
	allData.frameData[id].singleBox[selected].setAppear();
	return allData.frameData[id].singleBox[selected].getAppear();
    }

    /**
     * Returns the appear attribute of the SingleBox object at index selected.
     */
    public boolean getIBAppear(int selected) {
	return allData.frameData[id].singleBox[selected].getAppear();
    }

    /**
     * Toggles the disappear truth value of the SingleBox object at index selected,
     * updates appear and occluded appropriately.
     */
    public boolean setIBDisappear(int selected) {
	allData.frameData[id].singleBox[selected].setDisappear();
	return allData.frameData[id].singleBox[selected].getDisappear();
    }
    
    /**
     * Returns the disappear attribute of the SingleBox object at index selected.
     */
    public boolean getIBDisappear(int selected) {
	return allData.frameData[id].singleBox[selected].getDisappear();
    }

     /**
     * Toggles the occluded truth value of the SingleBox object at index selected,
     * updates disappear and appear appropriately.
     */
    public boolean setIBOccluded(int selected) {
	allData.frameData[id].singleBox[selected].setOccluded();
	return allData.frameData[id].singleBox[selected].getOccluded();
    }
    
    public boolean getIBOccluded(int selected) {
	return allData.frameData[id].singleBox[selected].getOccluded();
    }

    /**
     * Toggles the walk truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBWalk(int selected) {
	allData.frameData[id].singleBox[selected].setWalk();
	return allData.frameData[id].singleBox[selected].getWalk();
    }

    /**
     * Returns the walk attribute of the SingleBox object at index selected
     */
    public boolean getIBWalk(int selected) {
	return allData.frameData[id].singleBox[selected].getWalk();
    }
       
    /**
     * Toggles the run truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBRun(int selected) {
	allData.frameData[id].singleBox[selected].setRun();
	return allData.frameData[id].singleBox[selected].getRun();
    }
    
    /**
     * Returns the run attribute of the SingleBox object at index selected.
     */
    public boolean getIBRun(int selected) {
	return allData.frameData[id].singleBox[selected].getRun();
    }

    /**
     * Toggles the active truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBActive(int selected) {
	allData.frameData[id].singleBox[selected].setActive();
	return allData.frameData[id].singleBox[selected].getActive();
    }

    /**
     * Returns the active attribute of the SingleBox object at index selected.
     */
    public boolean getIBActive(int selected) {
	return allData.frameData[id].singleBox[selected].getActive();
    }

    /**
     * Toggles the inactive truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBInActive(int selected) {
	allData.frameData[id].singleBox[selected].setInActive();
	return allData.frameData[id].singleBox[selected].getInActive();
    }

    /**
     * Returns the inactive attribute of the SingleBox object at index selected.
     */
    public boolean getIBInActive(int selected) {
	return allData.frameData[id].singleBox[selected].getInActive();
    }

    /**
     * Toggles the fighter truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBFighter(int selected) {
	allData.frameData[id].singleBox[selected].setFighter();
	return allData.frameData[id].singleBox[selected].getFighter();
    }

    /**
     * Returns the fighter attribute of the SingleBox object at index selected.
     */
    public boolean getIBFighter(int selected) {
	return allData.frameData[id].singleBox[selected].getFighter();
    }

     /**
     * Toggles the browser truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBBrowser(int selected) {
	allData.frameData[id].singleBox[selected].setBrowser();
	return allData.frameData[id].singleBox[selected].getBrowser();
    }

    /**
     * Returns the browser attribute of the SingleBox object at index selected.
     */
    public boolean getIBBrowser(int selected) {
	return allData.frameData[id].singleBox[selected].getBrowser();
    }

    /**
     * Toggles the left behind truth value of the SingleBox object at index selected.
     */	
    public boolean setIBLeftBehind(int selected) {
	allData.frameData[id].singleBox[selected].setLeftBehind();
	return allData.frameData[id].singleBox[selected].getLeftBehind();
    }


    /**
     * Returns the left behind attribute of the SingleBox object at index selected.
     */
    public boolean getIBLeftBehind(int selected) {
	return allData.frameData[id].singleBox[selected].getLeftBehind();
    }
    
    /**
     * Toggles the leaving group truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBLeavingGroup(int selected) {
	allData.frameData[id].singleBox[selected].setLeavingGroup();
	return allData.frameData[id].singleBox[selected].getLeavingGroup();
    }

    /**
     * Returns the leaving group attribute of the SingleBox object at index selected.
     */
    public boolean getIBLeavingGroup(int selected) {
	return allData.frameData[id].singleBox[selected].getLeavingGroup();
    }

    /**
     * Toggles the walker truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBWalker(int selected) {
	allData.frameData[id].singleBox[selected].setWalker();
	return allData.frameData[id].singleBox[selected].getWalker();
    }

    /**
     * Returns the walker attribute of the SingleBox object at index selected.
     */
    public boolean getIBWalker(int selected) {
	return allData.frameData[id].singleBox[selected].getWalker();
    }

    /**
     * Returns the left object attribute of the SingleBox object at index selected.
     */
    public boolean getIBLeftObject(int selected) {
	return allData.frameData[id].singleBox[selected].getLeftObject();
    }

    /**
     * Toggles the left object truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBLeftObject(int selected) {
	allData.frameData[id].singleBox[selected].setLeftObject();
	return allData.frameData[id].singleBox[selected].getLeftObject();
    }

    /**
     * Toggles the moving sit truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBMovingSit(int selected) {
	allData.frameData[id].singleBox[selected].setMovingSit();
	return allData.frameData[id].singleBox[selected].getMovingSit();
    }

    /**
     * Returns the moving sit attribute of the SingleBox object at index selected.
     */
    public boolean getIBMovingSit(int selected) {
	return allData.frameData[id].singleBox[selected].getMovingSit();
    }

    /**
     * Toggles the shop enter sit truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBshopenterSit(int selected) {
	allData.frameData[id].singleBox[selected].setShopenterSit();
	return allData.frameData[id].singleBox[selected].getShopenterSit();
    }

    /**
     * Returns the shop enter sit attribute of the SingleBox object at index selected.
     */
    public boolean getIBshopenterSit(int selected) {
	return allData.frameData[id].singleBox[selected].getShopenterSit();
    }

    /**
     * Toggles the shop exit sit truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBshopexitSit(int selected) {
	allData.frameData[id].singleBox[selected].setShopexitSit();
	return allData.frameData[id].singleBox[selected].getShopexitSit();
    }

    /**
     * Returns the shop exit sit attribute of the SingleBox object at index selected.
     */
    public boolean getIBshopexitSit(int selected) {
	return allData.frameData[id].singleBox[selected].getShopexitSit();
    }

    /**
     * Toggles the window shop scenario truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBwindowshopSce(int selected) {
	allData.frameData[id].singleBox[selected].setWindowshopSce();
	return allData.frameData[id].singleBox[selected].getWindowshopSce();
    }

    /**
     * Returns the window shop scenario attribute of the SingleBox object at index selected.
     */
    public boolean getIBwindowshopSce(int selected) {
	return allData.frameData[id].singleBox[selected].getWindowshopSce();
    }

    /**
     * Toggles the shop enter scenario truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBshopenterSce(int selected) {
	allData.frameData[id].singleBox[selected].setShopenterSce();
	return allData.frameData[id].singleBox[selected].getShopenterSce();
    }

    /**
     * Returns the shop enter scenario attribute of the SingleBox object at index selected.
     */
    public boolean getIBshopenterSce(int selected) {
	return allData.frameData[id].singleBox[selected].getShopenterSce();
    }

    /**
     * Toggles the shop exit scenario truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBshopexitSce(int selected) {
	allData.frameData[id].singleBox[selected].setShopexitSce();
	return allData.frameData[id].singleBox[selected].getShopexitSce();
    }

    /**
     * Returns the shop exit scenario attribute of the SingleBox object at index selected.
     */
    public boolean getIBshopexitSce(int selected) {
	return allData.frameData[id].singleBox[selected].getShopexitSce();
    }

    /**
     * Toggles the shop reenter scenario truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBshopreenterSce(int selected) {
	allData.frameData[id].singleBox[selected].setShopreenterSce();
	return allData.frameData[id].singleBox[selected].getShopreenterSce();
    }

    /**
     * Returns the shop reenter scenario attribute of the SingleBox object at index selected.
     */
    public boolean getIBshopreenterSce(int selected) {
	return allData.frameData[id].singleBox[selected].getShopreenterSce();
    }
        
    /**
     * Toggles the inactive sit truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBInactiveSit(int selected) {
	allData.frameData[id].singleBox[selected].setInactiveSit();
	return allData.frameData[id].singleBox[selected].getInactiveSit();
    }

    /**
     * Returns the inactive sit attribute of the SingleBox object at index selected.
     */
    public boolean getIBInactiveSit(int selected) {
	return allData.frameData[id].singleBox[selected].getInactiveSit();
    }

    /**
     * Toggles the none rol truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
/*    public boolean setIBNonerol(int selected) {
	allData.frameData[id].singleBox[selected].setNoneRol();
	return allData.frameData[id].singleBox[selected].getNoneRol();
    }*/

    /**
     * Returns the none rol attribute of the SingleBox object at index selected.
     */
/*    public boolean getIBNonerol(int selected) {
	return allData.frameData[id].singleBox[selected].getNoneRol();
    }
*/
    /**
     * Toggles the none sit truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
/*    public boolean setIBNoneSit(int selected) {
	allData.frameData[id].singleBox[selected].setNoneSit();
	return allData.frameData[id].singleBox[selected].getNoneSit();
    }*/

    /**
     * Returns the none sit attribute of the SingleBox object at index selected.
     */
/*    public boolean getIBNoneSit(int selected) {
	return allData.frameData[id].singleBox[selected].getNoneSit();
    }*/

    /**
     * Toggles the none sce truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
/*    public boolean setIBNoneSce(int selected) {
	allData.frameData[id].singleBox[selected].setNoneSce();
	return allData.frameData[id].singleBox[selected].getNoneSce();
    }*/

    /**
     * Returns the none sce attribute of the SingleBox object at index selected.
     */
/*    public boolean getIBNoneSce(int selected) {
	return allData.frameData[id].singleBox[selected].getNoneSce();
    }*/

     /**
     * Toggles the browsing sit truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBBrowsingSit(int selected) {
	allData.frameData[id].singleBox[selected].setBrowsingSit();
	return allData.frameData[id].singleBox[selected].getBrowsingSit();
    }

    /**
     * Returns the browsing sit attribute of the SingleBox object at index selected.
     */
    public boolean getIBBrowsingSit(int selected) {
	return allData.frameData[id].singleBox[selected].getBrowsingSit();
    }

    /**
     * Toggles the browsing truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBBrowsing(int selected) {
	allData.frameData[id].singleBox[selected].setBrowsing();
	return allData.frameData[id].singleBox[selected].getBrowsing();
    }

    /**
     * Returns the browsing attribute of the SingleBox object at index selected.
     */
    public boolean getIBBrowsing(int selected) {
	return allData.frameData[id].singleBox[selected].getBrowsing();
    }

    /**
     * Toggles the immobile truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBImmobile(int selected) {
	allData.frameData[id].singleBox[selected].setImmobile();
	return allData.frameData[id].singleBox[selected].getImmobile();
    }

    /**
     * Returns the immobile attribute of the SingleBox object at index selected.
     */
    public boolean getIBImmobile(int selected) {
	return allData.frameData[id].singleBox[selected].getImmobile();
    }

    /**
     * Toggles the walking truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBWalking(int selected) {
	allData.frameData[id].singleBox[selected].setWalking();
	return allData.frameData[id].singleBox[selected].getWalking();
    }

    /**
     * Returns the walking attribute of the SingleBox object at index selected.
     */
    public boolean getIBWalking(int selected) {
	return allData.frameData[id].singleBox[selected].getWalking();
    }

    /**
     * Toggles the drop down truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBDropDown(int selected) {
	allData.frameData[id].singleBox[selected].setDropDown();
	return allData.frameData[id].singleBox[selected].getDropDown();
    }

    /**
     * Returns the drop down attribute of the SingleBox object at index selected.
     */
    public boolean getIBDropDown(int selected) {
	return allData.frameData[id].singleBox[selected].getDropDown();
    }

    /**
     * Toggles the person immobile truth value of the SingleBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setIBPersonImmobile(int selected) {
	allData.frameData[id].singleBox[selected].setPersonImmobile();
	return allData.frameData[id].singleBox[selected].getPersonImmobile();
    }

    /**
     * Returns the person immobile attribute of the SingleBox object at index selected.
     */
    public boolean getIBPersonImmobile(int selected) {
	return allData.frameData[id].singleBox[selected].getPersonImmobile();
    }

    //PTC
    public boolean setIBNoneMov(int selected) {
	allData.frameData[id].singleBox[selected].setNoneMov();
	return allData.frameData[id].singleBox[selected].getNoneMov();
    }

    public boolean getIBNoneMov(int selected) {
	return allData.frameData[id].singleBox[selected].getNoneMov();
    }

    public boolean setIBNoneRol(int selected) {
	allData.frameData[id].singleBox[selected].setNoneRol();
	return allData.frameData[id].singleBox[selected].getNoneRol();
    }

    public boolean getIBNoneRol(int selected) {
	return allData.frameData[id].singleBox[selected].getNoneRol();
    }

    public boolean setIBNoneSce(int selected) {
	allData.frameData[id].singleBox[selected].setNoneSce();
	return allData.frameData[id].singleBox[selected].getNoneSce();
    }

    public boolean getIBNoneSce(int selected) {
	return allData.frameData[id].singleBox[selected].getNoneSce();
    }

    public boolean setIBNoneSit(int selected) {
	allData.frameData[id].singleBox[selected].setNoneSit();
	return allData.frameData[id].singleBox[selected].getNoneSit();
    }

    public boolean getIBNoneSit(int selected) {
	return allData.frameData[id].singleBox[selected].getNoneSit();
    }

    public boolean setGBNoneMov(int selected) {
	allData.frameData[id].groupBox[selected].setNoneMov();
	return allData.frameData[id].groupBox[selected].getNoneMov();
    }

    public boolean getGBNoneMov(int selected) {
	return allData.frameData[id].groupBox[selected].getNoneMov();
    }

    public boolean setGBNoneRol(int selected) {
	allData.frameData[id].groupBox[selected].setNoneRol();
	return allData.frameData[id].groupBox[selected].getNoneRol();
    }

    public boolean getGBNoneRol(int selected) {
	return allData.frameData[id].groupBox[selected].getNoneRol();
    }

    public boolean setGBNoneSce(int selected) {
	allData.frameData[id].groupBox[selected].setNoneSce();
	return allData.frameData[id].groupBox[selected].getNoneSce();
    }

    public boolean getGBNoneSce(int selected) {
	return allData.frameData[id].groupBox[selected].getNoneSce();
    }

    public boolean setGBNoneSit(int selected) {
	allData.frameData[id].groupBox[selected].setNoneSit();
	return allData.frameData[id].groupBox[selected].getNoneSit();
    }

    public boolean getGBNoneSit(int selected) {
	return allData.frameData[id].groupBox[selected].getNoneSit();
    }
    //END PTC

    /** 
     * Method for selecting a group box from the control panel.
     */
    public void setGroupSelected(int index) {
	if (index < allData.frameData[id].groupBox.length) {
	    for (int i = 0; i < allData.frameData[id].singleBox.length; i++) {
		allData.frameData[id].singleBox[i].setSelected(false);
	    }
	    for (int i = 0; i < allData.frameData[id].groupBox.length; i++) {
		allData.frameData[id].groupBox[i].setSelected(false);
	    }
	    allData.frameData[id].groupBox[index].setSelected(true);
	    groupBoxUpdateDisplay(index);
	}
    }
    
	/** 
	 * Method for selecting a single box from the control panel.
	 */
	public void setSingleSelected(int index) {
	if (index < allData.frameData[id].singleBox.length) {
		for (int i = 0; i < allData.frameData[id].singleBox.length; i++) {
		allData.frameData[id].singleBox[i].setSelected(false);
		}
		for (int i = 0; i < allData.frameData[id].groupBox.length; i++) {
		allData.frameData[id].groupBox[i].setSelected(false);
		}
		allData.frameData[id].singleBox[index].setSelected(true);
		singleBoxUpdateDisplay(index);
	}
	}    


    
    /**
     * Deletes the GroupBox object at index selected.
     */
    public void deleteGroBox(int selected) {
	allData.frameData[id].groupBox[selected] = new GroupBox();
	setGroupSelected(selected);
    }

    /**
     * Checks if the GroupBox object at index selected is empty.
     */
    public boolean isEmptyGroBox(int selected){
    GroupBox box=allData.frameData[id].groupBox[selected];    
    return box.isDefault();  
    }

    /**
     * Checks if the SingleBox object at index selected is empty.
     */
    public boolean isEmptySingleBox(int selected){
    SingleBox box=allData.frameData[id].singleBox[selected];    
    return box.isDefault();  
    }
    
    public boolean singleBoxinGroupBox(int selected){
    boolean exist=false;
    for (int i=0;i<FrameData.GROUP_BOXES;i++)
    	{
    	boolean truth=allData.frameData[id].groupBox[i].getIndBoxAt(selected);    
	   if (truth==true)
	   	exist=true;
	   }
	 return exist;
    }

    /** 
     * Gets the rectangle object representing the box for SingleBox number selected
     */
    public Rectangle getGroupBox(int selected) {
	return allData.frameData[id].groupBox[selected].getBox();
    }

    /**
     * Sets the GroupBox object at index selected axis attribute to update.
     */
    public void setGBAxis(int selected, int update) {
	allData.frameData[id].groupBox[selected].setAxis(update);
	groupBoxUpdateDisplay(selected);
    }

    /**
     * Returns the GroupBox object at index selected axis attribute.
     */
    public int getGBAxis(int selected) {
	return allData.frameData[id].groupBox[selected].getAxis();
    }

    /** 
     * Sets the currently selected GroupBox object to have the selected
     * items represented by the string inputString. inputString checked for
     * errors in CAVIARGUI.java
     */
    public void setGBIBoxes(int selected, String[] inputString) {
	allData.frameData[id].groupBox[selected].setIndBoxes(inputString);
    }
    
    /**
     * Gets the boolean array representing the individual boxes contained within
     * the GroupBox object
     */
    public boolean[] getGBIBoxes(int selected) {
	return allData.frameData[id].groupBox[selected].getIndBoxes();
    }

    /**
     * Toggles the appear truth value of the GroupBox object at index selected,
     * updates disappear appropriately.
     */
    public boolean setGBAppear(int selected) {
	allData.frameData[id].groupBox[selected].setAppear();
	return allData.frameData[id].groupBox[selected].getAppear();
    }

    /**
     * Returns the appear attribute of the GroupBox object at index selected.
     */
    public boolean getGBAppear(int selected) {
	return allData.frameData[id].groupBox[selected].getAppear();
    }

    /**
     * Toggles the disappear truth value of the GroupBox object at index selected,
     * updates appear appropriately.
     */
    public boolean setGBDisappear(int selected) {
	allData.frameData[id].groupBox[selected].setDisappear();
	return allData.frameData[id].groupBox[selected].getDisappear();
    }

    /**
     * Returns the disappear attribute of the GroupBox object at index selected.
     */
    public boolean getGBDisappear(int selected) {
	return allData.frameData[id].groupBox[selected].getDisappear();
    }
	
    /**
     * Toggles the active truth value of the GroupBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setGBActive(int selected) {
	allData.frameData[id].groupBox[selected].setActive();
	return allData.frameData[id].groupBox[selected].getActive();
    }

    /**
     * Returns the active attribute of the GroupBox object at index selected.
     */
    public boolean getGBActive(int selected) {
	return allData.frameData[id].groupBox[selected].getActive();
    }
    
    /**
     * Toggles the inactive truth value of the GroupBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setGBInActive(int selected) {
	allData.frameData[id].groupBox[selected].setInActive();
	return allData.frameData[id].groupBox[selected].getInActive();
    }
    
    /**
     * Returns the inactive attribute of the GroupBox object at index selected.
     */
    public boolean getGBInActive(int selected) {
	return allData.frameData[id].groupBox[selected].getInActive();
    }

    /**
     * Toggles the move truth value of the GroupBox object at index selected,
     * updates other parameters appropriately.
     */	
    public boolean setGBMove(int selected) {
	allData.frameData[id].groupBox[selected].setMove();
	return allData.frameData[id].groupBox[selected].getMove();
    }

    /**
     * Returns the move attribute of the GroupBox object at index selected.
     */
    public boolean getGBMove(int selected) {
	return allData.frameData[id].groupBox[selected].getMove();
    }

    /**
     * Toggles the fight truth value of the GroupBox object at index selected,
     * updates meet appropriately.
     */	
    public boolean setGBFight(int selected) {
	allData.frameData[id].groupBox[selected].setFight();
	return allData.frameData[id].groupBox[selected].getFight();
    }

    /**
     * Returns the fight attribute of the GroupBox object at index selected.
     */
    public boolean getGBFight(int selected) {
	return allData.frameData[id].groupBox[selected].getFight();
    }
    
    /**
     * Toggles the meet truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBMeet(int selected) {
	allData.frameData[id].groupBox[selected].setMeet();
	return allData.frameData[id].groupBox[selected].getMeet();
    }
    
    /**
     * Returns the meet attribute of the GroupBox object at index selected.
     */
    public boolean getGBMeet(int selected) {
	return allData.frameData[id].groupBox[selected].getMeet();
    }

    /**
     * Toggles the walk truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBWalk(int selected) {
	allData.frameData[id].groupBox[selected].setWalk();
	return allData.frameData[id].groupBox[selected].getWalk();
    }
    
    /**
     * Returns the walk attribute of the GroupBox object at index selected.
     */
    public boolean getGBWalk(int selected) {
	return allData.frameData[id].groupBox[selected].getWalk();
    }

    /**
     * Toggles the gbnone rol truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
/*    public boolean setGBNoneRol(int selected) {
	allData.frameData[id].groupBox[selected].setNoneRol();
	return allData.frameData[id].groupBox[selected].getNoneRol();
    }*/
    
    /**
     * Returns the gbnone rol attribute of the GroupBox object at index selected.
     */
/*    public boolean getGBNoneRol(int selected) {
	return allData.frameData[id].groupBox[selected].getNoneRol();
    }
*/

    /**
     * Toggles the shop enter truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBshopenterSit(int selected) {
	allData.frameData[id].groupBox[selected].setShopenterSit();
	return allData.frameData[id].groupBox[selected].getShopenterSit();
    }
    
    /**
     * Returns the shop enter attribute of the GroupBox object at index selected.
     */
    public boolean getGBshopenterSit(int selected) {
	return allData.frameData[id].groupBox[selected].getShopenterSit();
    }

    /**
     * Toggles the shop exit situation truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBshopexitSit(int selected) {
	allData.frameData[id].groupBox[selected].setShopexitSit();
	return allData.frameData[id].groupBox[selected].getShopexitSit();
    }
    
    /**
     * Returns the shop exit situation attribute of the GroupBox object at index selected.
     */
    public boolean getGBshopexitSit(int selected) {
	return allData.frameData[id].groupBox[selected].getShopexitSit();
    }

    /**
     * Toggles the window shop scenario truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBwindowshopSce(int selected) {
	allData.frameData[id].groupBox[selected].setWindowshopSce();
	return allData.frameData[id].groupBox[selected].getWindowshopSce();
    }
    
    /**
     * Returns the window shop scenario attribute of the GroupBox object at index selected.
     */
    public boolean getGBwindowshopSce(int selected) {
	return allData.frameData[id].groupBox[selected].getWindowshopSce();
    }

    /**
     * Toggles the shop enter scenario truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBshopenterSce(int selected) {
	allData.frameData[id].groupBox[selected].setShopenterSce();
	return allData.frameData[id].groupBox[selected].getShopenterSce();
    }
    
    /**
     * Returns the shop enter scenario attribute of the GroupBox object at index selected.
     */
    public boolean getGBshopenterSce(int selected) {
	return allData.frameData[id].groupBox[selected].getShopenterSce();
    }
        
    /**
     * Toggles the shop exit scenario truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBshopexitSce(int selected) {
	allData.frameData[id].groupBox[selected].setShopexitSce();
	return allData.frameData[id].groupBox[selected].getShopexitSce();
    }
    
    /**
     * Returns the shop exit scenario attribute of the GroupBox object at index selected.
     */
    public boolean getGBshopexitSce(int selected) {
	return allData.frameData[id].groupBox[selected].getShopexitSce();
    }

    /**
     * Toggles the shop reenter scenario truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBshopreenterSce(int selected) {
	allData.frameData[id].groupBox[selected].setShopreenterSce();
	return allData.frameData[id].groupBox[selected].getShopreenterSce();
    }
    
    /**
     * Returns the shop reenter scenario attribute of the GroupBox object at index selected.
     */
    public boolean getGBshopreenterSce(int selected) {
	return allData.frameData[id].groupBox[selected].getShopreenterSce();
    }
        
    /**
     * Toggles the browser role truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBbrowserRole(int selected) {
	allData.frameData[id].groupBox[selected].setBrowserRole();
	return allData.frameData[id].groupBox[selected].getBrowserRole();
    }
    
    /**
     * Returns the browser role attribute of the GroupBox object at index selected.
     */
    public boolean getGBbrowserRole(int selected) {
	return allData.frameData[id].groupBox[selected].getBrowserRole();
    }

    /**
     * Toggles the walking scenario truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBwalkingSce(int selected) {
	allData.frameData[id].groupBox[selected].setWalkingSce();
	return allData.frameData[id].groupBox[selected].getWalkingSce();
    }
    
    /**
     * Returns the walking scenario attribute of the GroupBox object at index selected.
     */
    public boolean getGBwalkingSce(int selected) {
	return allData.frameData[id].groupBox[selected].getWalkingSce();
    }

    /**
     * Toggles the group fighting truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBGrFighting(int selected) {
	allData.frameData[id].groupBox[selected].setGrFighting();
	return allData.frameData[id].groupBox[selected].getGrFighting();
    }
    
    /**
     * Returns the group fighting attribute of the GroupBox object at index selected.
     */
    public boolean getGBGrFighting(int selected) {
	return allData.frameData[id].groupBox[selected].getGrFighting();
    }

    /**
     * Toggles the group moving truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBGrMoving(int selected) {
	allData.frameData[id].groupBox[selected].setGrMoving();
	return allData.frameData[id].groupBox[selected].getGrMoving();
    }
    
    /**
     * Returns the group moving attribute of the GroupBox object at index selected.
     */
    public boolean getGBGrMoving(int selected) {
	return allData.frameData[id].groupBox[selected].getGrMoving();
    }

    /**
     * Toggles the group meeting truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBGrMeeting(int selected) {
	allData.frameData[id].groupBox[selected].setGrMeeting();
	return allData.frameData[id].groupBox[selected].getGrMeeting();
    }
    
    /**
     * Returns the group meeting attribute of the GroupBox object at index selected.
     */
    public boolean getGBGrMeeting(int selected) {
	return allData.frameData[id].groupBox[selected].getGrMeeting();
    }

    /**
     * Toggles the group interacting truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBGrInteracting(int selected) {
	allData.frameData[id].groupBox[selected].setGrInteracting();
	return allData.frameData[id].groupBox[selected].getGrInteracting();
    }
    
    /**
     * Returns the group interacting attribute of the GroupBox object at index selected.
     */
    public boolean getGBGrInteracting(int selected) {
	return allData.frameData[id].groupBox[selected].getGrInteracting();
    }

    /**
     * Toggles the group splitting truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBGrSplitting(int selected) {
	allData.frameData[id].groupBox[selected].setGrSplitting();
	return allData.frameData[id].groupBox[selected].getGrSplitting();
    }
    
    /**
     * Returns the group splitting attribute of the GroupBox object at index selected.
     */
    public boolean getGBGrSplitting(int selected) {
	return allData.frameData[id].groupBox[selected].getGrSplitting();
    }

    /**
     * Toggles the group inactive truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBGrInactive(int selected) {
	allData.frameData[id].groupBox[selected].setGrInactive();
	return allData.frameData[id].groupBox[selected].getGrInactive();
    }
    
    /**
     * Returns the group inactive attribute of the GroupBox object at index selected.
     */
    public boolean getGBGrInactive(int selected) {
	return allData.frameData[id].groupBox[selected].getGrInactive();
    }

    /**
     * Toggles the left behind truth value of the GroupBox object at index selected.
     */	
    public boolean setGBLeftBehind(int selected) {
	allData.frameData[id].groupBox[selected].setLeftBehind();
	return allData.frameData[id].groupBox[selected].getLeftBehind();
    }

    /**
     * Returns the left behind attribute of the GroupBox object at index selected.
     */
    public boolean getGBLeftBehind(int selected) {
	return allData.frameData[id].groupBox[selected].getLeftBehind();
    }

    /**
     * Toggles the left behind truth value of the GroupBox object at index selected.
     */	
    public boolean setGBLeftObject(int selected) {
	allData.frameData[id].groupBox[selected].setLeftObject();
	return allData.frameData[id].groupBox[selected].getLeftObject();
    }

    /**
     * Returns the left behind attribute of the GroupBox object at index selected.
     */
    public boolean getGBLeftObject(int selected) {
	return allData.frameData[id].groupBox[selected].getLeftObject();
    }

    /**
     * Toggles the fighting truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBFighting(int selected) {
	allData.frameData[id].groupBox[selected].setFighting();
	return allData.frameData[id].groupBox[selected].getFighting();
    }
    
    /**
     * Returns the fighting attribute of the GroupBox object at index selected.
     */
    public boolean getGBFighting(int selected) {
	return allData.frameData[id].groupBox[selected].getFighting();
    }

    /**
     * Toggles the meeting truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBMeeting(int selected) {
	allData.frameData[id].groupBox[selected].setMeeting();
	return allData.frameData[id].groupBox[selected].getMeeting();
    }
    
    /**
     * Returns the meeting attribute of the GroupBox object at index selected.
     */
    public boolean getGBMeeting(int selected) {
	return allData.frameData[id].groupBox[selected].getMeeting();
    }

    /**
     * Toggles the leaving truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBLeaving(int selected) {
	allData.frameData[id].groupBox[selected].setLeaving();
	return allData.frameData[id].groupBox[selected].getLeaving();
    }
    
    /**
     * Returns the leaving attribute of the GroupBox object at index selected.
     */
    public boolean getGBLeaving(int selected) {
	return allData.frameData[id].groupBox[selected].getLeaving();
    }

    /**
     * Toggles the fight start truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBFightStart(int selected) {
	allData.frameData[id].groupBox[selected].setFightStart();
	return allData.frameData[id].groupBox[selected].getFightStart();
    }
    
    /**
     * Returns the fight start attribute of the GroupBox object at index selected.
     */
    public boolean getGBFightStart(int selected) {
	return allData.frameData[id].groupBox[selected].getFightStart();
    }

    /**
     * Toggles the fight end truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBFightEnd(int selected) {
	allData.frameData[id].groupBox[selected].setFightEnd();
	return allData.frameData[id].groupBox[selected].getFightEnd();
    }
    
    /**
     * Returns the fight end attribute of the GroupBox object at index selected.
     */
    public boolean getGBFightEnd(int selected) {
	return allData.frameData[id].groupBox[selected].getFightEnd();
    }
    
    /**
     * Toggles the victim left truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBFightVictimLeft(int selected) {
	allData.frameData[id].groupBox[selected].setFightVictimLeft();
	return allData.frameData[id].groupBox[selected].getFightVictimLeft();
    }
    
    /**
     * Returns the victim left attribute of the GroupBox object at index selected.
     */
    public boolean getGBFightVictimLeft(int selected) {
	return allData.frameData[id].groupBox[selected].getFightVictimLeft();
    }

    /**
     * Toggles the browsing sit truth value of the GroupBox object at index selected,
     * updates fight appropriately.
     */	
    public boolean setGBbrowsingSit(int selected) {
	allData.frameData[id].groupBox[selected].setBrowsingSit();
	return allData.frameData[id].groupBox[selected].getBrowsingSit();
    }
    
    /**
     * Returns the browsing sit attribute of the GroupBox object at index selected.
     */
    public boolean getGBbrowsingSit(int selected) {
	return allData.frameData[id].groupBox[selected].getBrowsingSit();
    }

    /**
     * Method to check to see whether the group boxes are still valid,
     * called before saving and moving between frames so that an invalid,
     * ie some singe boxes not contained within the group box, never 
     * happens
     */
    public boolean checkGroupBoxes() {
	for (int i = 0; i < FrameData.GROUP_BOXES; i++) {
	    GroupBox g  = allData.frameData[id].groupBox[i];
	    Rectangle gBox = allData.frameData[id].groupBox[i].getBox();
	    if (gBox != null) {
		for (int j = 0; j < g.indBoxes.length; j++) {
		    if (g.indBoxes[j]) {
			Rectangle sBox = allData.frameData[id].singleBox[j].getBox();
			
			if (! (sBox.getX() >= gBox.getX() &&
			       (sBox.getX() + sBox.getWidth()) <= (gBox.getX() + gBox.getWidth()) &&
			       sBox.getY() >= gBox.getY() &&
			       (sBox.getY() + sBox.getHeight()) <= (gBox.getY() + gBox.getHeight()))) {
			    JOptionPane.showMessageDialog(null,("Invalid Group Box object - Individual\n"+
								"Box "+j+" is no longer contained within Group Box\n"+
								+j+" despite being selected as part of that object"),
							  "Group Box Error", JOptionPane.ERROR_MESSAGE);
			    return false;
			}
		    }
		}
	    }
	}
	return true;
    }

    /** 
     * Simple method that contunually calls loadNext to give and 
     * illusion of there being playback of the video.
     */
    public void play() {
	int checkId = id;
	//PTC
	boolean pc = performCheck;
	performCheck = false;
	do {
	    loadNext();
	    ++checkId;
	} while (checkId == id);
	performCheck = pc;
    }

    /** 
     * Loads a new JPG sequence (seqName) stored in directory jpgs, 
     * and resets all of the data currently stored.
     */ 
    public boolean loadNewSeq(String tempSeqName, boolean hundredsFlag) {

	int tempId = 0;
	int tempMax = 0;
	String tempFileName = "";
	boolean tempHundreds = hundredsFlag;
	File tempImageFile = null;
	Image tempImage = null;

	// add .jpg extension if user has not
	/*if (tempFileName.length() >= 4 && ! (tempFileName.substring(tempFileName.length()-4,tempFileName.length()-1).equals("jpg"))) {
	    tempFileName = tempFileName+".jpg";
	    }*/

	/*if (hundreds) {
	    tempSeqName = tempFileName.substring(0,tempFileName.lastIndexOf('.')-3);
	} else {
	    tempSeqName = tempFileName.substring(0,tempFileName.lastIndexOf('.')-4);
	    }*/

	//try {
		
	if (tempHundreds) {
	    //tempId = Integer.parseInt(tempFileName.substring((tempFileName.lastIndexOf('.'))-3,(tempFileName.lastIndexOf('.'))));
	    //if (tempMax < tempId) { tempMax = tempId; }
	    tempFileName = tempSeqName+"00"+tempId+".jpg";
	    frameNumber.setText("Frame: "+ tempId + " in sequence " + tempSeqName);
	} else {
	    //tempId = Integer.parseInt(tempFileName.substring((tempSeqName.lastIndexOf('.'))-4,(tempSeqName.lastIndexOf('.'))));
	    //if (tempMax < tempId) { tempMax = tempId; }
	    tempFileName = tempSeqName+"000"+tempId+".jpg";
	    frameNumber.setText("Frame: "+ tempId + " in sequence " + tempSeqName);
	}
	
	tempImageFile = new File(tempSeqName+"/JPEGS/"+tempFileName);
	
	try {
	    
	    tempImage = ImageIO.read(tempImageFile);
	} catch (IOException ioe) {
	    JOptionPane.showMessageDialog(null,("Unable to load: \n"+tempFileName+
						"\nCheck file name\n"+
						"Remeber must be stored in directory "+tempSeqName),
					      "Load Error", JOptionPane.ERROR_MESSAGE);
	    frameNumber.setText("File not loaded");
	    ioe.printStackTrace();
	    return false;
	} catch (NullPointerException npe) {
	    JOptionPane.showMessageDialog(null,("Null Pointer Exception\n Loading: "+tempFileName+"\n"+
						"Check file name\n"+
						"Remember must be stored in directory "+tempSeqName),
					  "Load Error", JOptionPane.ERROR_MESSAGE);
	    frameNumber.setText("File not loaded");
	    npe.printStackTrace();
	    return false;
	}
	

	
	// initialise data structure for representing frame and data
	    	   
	allData = new AllData();
	allData.frameData[tempId] = new FrameData();
		
	// update values
	fileName = tempFileName;
	seqName = tempSeqName;
	max = tempMax;
	id = tempId;
	hundreds = tempHundreds;
	imageFile = tempImageFile;
	image = tempImage;

	canvas.loadImage(image);

	int index = allData.frameData[tempId].getSelected();
	if (index < FrameData.SINGLE_BOXES) {
	    singleBoxUpdateDisplay(index);
	} else {
	    groupBoxUpdateDisplay(index-FrameData.SINGLE_BOXES);
	}
	
	/*} catch (IOException ioe) {
	  JOptionPane.showMessageDialog(null,("Unable to load: \n"+tempFileName+
	  "\nCheck file name\n"+
	  "Remeber must be stored in directory "+tempSeqName),
	  "Load Error", JOptionPane.ERROR_MESSAGE);
	    frameNumber.setText("File not loaded");
	    ioe.printStackTrace();
	    return false;
	    } catch (NullPointerException npe) {
	    JOptionPane.showMessageDialog(null,("Null Pointer Exception\n Loading: "+tempFileName+"\n"+
	    "Check file name\n"+
						"Remember must be stored in directory "+tempSeqName),
						"Load Error", JOptionPane.ERROR_MESSAGE);
						frameNumber.setText("File not loaded");
						npe.printStackTrace();
						return false;
						}*/
	return true;
    }	

	public void loadFile(String seqName,String fileName){
		String data = allData.readFrom(seqName,fileName);	
	}

    /**
     * Loads xml file fileName and resets all the datastructures to represent
     * the data in this file.
     */
    public boolean loadFile(String fileName/*, boolean hundreds*/) {
	//this.hundreds = hundreds;
	String data = allData.readFrom(seqName,fileName);
	if (data.length() < 3) {
	    // must have been an error
	    return false;
	} else {
	    String[] parts = data.split("[\n]");
	    
	    seqName = parts[0];
	    id = Integer.parseInt(parts[1]);
	    max = id;
	    if (id < 10) {
		if (hundreds) {
		    fileName = parts[0]+"00"+id+".jpg";
		} else {
		    fileName = parts[0]+"000"+id+".jpg";
		}
	    } else if (id < 100) {
		if (hundreds) {
		    fileName = parts[0]+"0"+id+".jpg";
		} else {
		    fileName = parts[0]+"00"+id+".jpg";
		}
	    } else if (id < 1000) {
		if (hundreds) {
		    fileName = parts[0]+id+".jpg";
		} else {
		    fileName = parts[0]+"0"+id+".jpg";
		}
	    } else {
		fileName = parts[0]+id+".jpg";
	    }
	    
	    if (hundreds) {
		frameNumber.setText("Frame: " + id + " in sequence " + seqName);
	    } else {
		frameNumber.setText("Frame: " + id + " in sequence " + seqName);
	    }
	    
	    /* ALTERED */
	    try {
		imageFile = new File(seqName+"/JPEGS/"+fileName);
//		System.out.println(" seqName "+seqName+"  reading from "+(seqName+"/JPEGS/"+fileName));
		image = ImageIO.read(imageFile);
		canvas.loadImage(image);
	    } catch (IOException ioe) {
		JOptionPane.showMessageDialog(null,("Unable to load: \n"+seqName),
					      "Load Error", JOptionPane.ERROR_MESSAGE);
		frameNumber.setText("File not loaded");
		ioe.printStackTrace();
		frameNumber.setText("Image "+seqName+" failed to load,\n check there is a jpg file of that name\n in the "+seqName+" directory");
	    }
	    setSingleSelected(0);
	    return true;
	}
    }

    /**
     * Saves the data already annotated to a new text file called fileName.
     */
    public boolean saveAsFile(String xmlFileName) {
	if (checkGroupBoxes()) {
	    allData.writeTo(seqName,max,xmlFileName);
	    return true;
	}
	return false;
    }

    //PTC
    public void setPerformCheck(){
	performCheck = !performCheck;
    }
    //END PTC

    /**
     * Loads the previous frame, copying all the data stored in the current
     * frame to the previous one.
     */
    public void copyToPrev() {
	//PTC
	if(performCheck && 
		!CheckConsistency.checkFrame(allData.frameData[id])) return;
	if (checkGroupBoxes()) {
	    --id;
	    
	    if (id >= 0) {
		
		// must always be able to load previous frame as it must have
		// been edited
		
		// added as a fail safe
		// if the loaded frame is null and its successor is not null
		// load frame with same contents as its successor, otherwise
		// add a new FrameData object
	   
		if (allData.frameData[id+1] != null) {
		    allData.frameData[id] = new FrameData(allData.frameData[id+1].getSingleBoxes(),
							  allData.frameData[id+1].getGroupBoxes());
		} else {
		    allData.frameData[id] = new FrameData();
		}
		
		
		// figure out name of next file
		if (id < 10) {
		    if (hundreds) {
			fileName = /*fileName.substring(0,fileName.lastIndexOf(".")-3)*/
			    seqName+"00"+id+".jpg";
		    } else {
			fileName = /*fileName.substring(0,fileName.lastIndexOf(".")-4)*/
			    seqName+"000"+id+".jpg";
		    }
		} else if (id < 100) {
		    if (hundreds) {
			fileName = /*fileName.substring(0,fileName.lastIndexOf(".")-3)*/
			    seqName+"0"+id+".jpg";
		    } else {
			fileName = /*fileName.substring(0,fileName.lastIndexOf(".")-4)*/
			    seqName+"00"+id+".jpg";
		    }
		} else if (id < 1000) {
		    if (hundreds) {
			fileName = /*fileName.substring(0,fileName.lastIndexOf(".")-3)*/
			    seqName+id+".jpg";
		    } else {
			fileName = /*fileName.substring(0,fileName.lastIndexOf(".")-4)*/
			    seqName+"0"+id+".jpg";
		    }
		} else {
		    fileName = /*fileName.substring(0,fileName.lastIndexOf(".")-4)*/
			seqName+id+".jpg";
		}
		
		if (hundreds) {
		    frameNumber.setText("Frame: "+ id + " in sequence "+ seqName/*.substring(0,seqName.lastIndexOf('.')-3)*/);
		} else {
		    frameNumber.setText("Frame: "+ id + " in sequence "+ seqName/*.substring(0,seqName.lastIndexOf('.')-4)*/);
		}
		
		// load image file ...
		try {
		    imageFile = new File(seqName+"/JPEGS/"+fileName);
		    image = ImageIO.read(imageFile);
		} catch (IOException ioe) {
		    JOptionPane.showMessageDialog(null,("Unable to load1: \n"+seqName+"\n from local directory "+seqName),
						  "Load Error", JOptionPane.ERROR_MESSAGE);
		    ioe.printStackTrace();
		}
		
		// load image into canvas
		
		canvas.loadImage(image);
		
		int selected = 0;
		
		if (id > 0 && allData.frameData[id-1] != null) {
		    selected = allData.frameData[id-1].getSelected();
		} else {
		    selected = allData.frameData[id].getSelected();
		}
		

		if (selected < FrameData.SINGLE_BOXES) {
		    setSingleSelected(selected);
		} else {
		    setGroupSelected(selected-FrameData.SINGLE_BOXES);
		}
		
	    } else {
		JOptionPane.showMessageDialog(null,("Cannot go to prev frame. \nAt first frame in sequence"),
					      "Load Error", JOptionPane.WARNING_MESSAGE);
		id = 0;
	    }
	}
    }

    /**
     * Loads the previous frame, will load the currently stored data unless none
     * is stored already.
     */
    public void loadPrev() {
	//PTC
	if(performCheck &&
		!CheckConsistency.checkFrame(allData.frameData[id])) return;
	if (checkGroupBoxes()) {
	    
	    --id;
	    
	    if (id >= 0) {
		
		if (allData.frameData[id] == null) {
		    // create new FrameData object
		    allData.frameData[id] = new FrameData();
		}
		
		// figure out name of next file
		if (id < 10) {
		    if (hundreds) {
			fileName = /*fileName.substring(0,fileName.lastIndexOf(".")-3)*/
			    seqName+"00"+id+".jpg";
		    } else {
			fileName = /*fileName.substring(0,fileName.lastIndexOf(".")-4)*/
			    seqName+"000"+id+".jpg";
		    }
		} else if (id < 100) {
		    if (hundreds) {
			fileName = /*fileName.substring(0,fileName.lastIndexOf(".")-3)*/
			    seqName+"0"+id+".jpg";
		    } else {
			fileName = /*fileName.substring(0,fileName.lastIndexOf(".")-4)*/
			    seqName+"00"+id+".jpg";
		    }
		} else if (id < 1000) {
		    if (hundreds) {
			fileName = /*fileName.substring(0,fileName.lastIndexOf(".")-3)*/
			    seqName+id+".jpg";
		    } else {
			fileName = /*fileName.substring(0,fileName.lastIndexOf(".")-4)*/
			    seqName+"0"+id+".jpg";
		    }
		} else {
		    fileName = /*fileName.substring(0,fileName.lastIndexOf(".")-4)*/
			seqName+id+".jpg";
		}
		
		if (hundreds) {
		    frameNumber.setText("Frame: "+ id + " in sequence "+ seqName/*.substring(0,seqName.lastIndexOf('.')-3)*/);
		} else {
		    frameNumber.setText("Frame: "+ id + " in sequence "+ seqName/*.substring(0,seqName.lastIndexOf('.')-4)*/);
		}
		
		// load image file ...
		try {
		    imageFile = new File(seqName+"/JPEGS/"+fileName);
		    image = ImageIO.read(imageFile);
		} catch (IOException ioe) {
		    JOptionPane.showMessageDialog(null,("Unable to load2: \n"+fileName+"\n from local directory "+seqName),
						  "Load Error", JOptionPane.ERROR_MESSAGE);
		    ioe.printStackTrace();
		}
		
		// load image into canvas
		
		canvas.loadImage(image);
		
  		int selected = 0;
		if (allData.frameData[id+1] != null) {
		    selected = allData.frameData[id+1].getSelected();
		} else {
		    selected = allData.frameData[id].getSelected();
		}
		
		if (selected < FrameData.SINGLE_BOXES) {
		    setSingleSelected(selected);
		} else {
		    setGroupSelected(selected-FrameData.SINGLE_BOXES);
		}
		
	    } else {
		JOptionPane.showMessageDialog(null,("Cannot go to prev frame. \nAt first frame in sequence"),
					      "Load Error", JOptionPane.WARNING_MESSAGE);
		id = 0;
	    }
	}
    }

    /**
     * Copys the data from the current frame into the next frame and loads the next frame.
     */
    public void copyToNext() {
	
	//PTC
	if(performCheck && 
		!CheckConsistency.checkFrame(allData.frameData[id])) return;
	if (id+1 < AllData.FRAMES) {

	    if (checkGroupBoxes()) {
		
		++id;
		
		String tempFileName = "";
		// figure out name of next file
		if (id < 10) {
		    if (hundreds) {
			tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-3)*/
			    +"00"+id+".jpg";
		    } else {
			tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-4)*/
			    +"000"+id+".jpg";
		    }
		} else if (id < 100) {
		    if (hundreds) {
			tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-3)*/
			    +"0"+id+".jpg";
		    } else {
			tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-4)*/
			    +"00"+id+".jpg";
		    }
		} else if (id < 1000) {
		    if (hundreds) {
			tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-3)*/
			    +id+".jpg";
		    } else {
			tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-4)*/
			    +"0"+id+".jpg";
		    }
		} else {
		    tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-4)*/
			+id+".jpg";
		}
		
		// load image file ...
		try {
		    imageFile = new File(seqName+"/JPEGS/"+tempFileName);
		    image = ImageIO.read(imageFile);
		    
		    fileName = tempFileName;
		    
		    if (hundreds) {
			frameNumber.setText("Frame: "+ id + " in sequence "+ seqName/*.substring(0,seqName.lastIndexOf('.')-3)*/);
		    } else {
			frameNumber.setText("Frame: "+ id + " in sequence "+ seqName/*.substring(0,seqName.lastIndexOf('.')-4)*/);
		    }
		    
		    // if prev frame not null reload its contents into new frame,
		    // otherwise create a new empty frame data object
		    
		    if (allData.frameData[id-1] != null) {
			allData.frameData[id] = new FrameData(allData.frameData[id-1].getSingleBoxes(),
							      allData.frameData[id-1].getGroupBoxes());
		    } else {
			allData.frameData[id] = new FrameData();
		    }
		    
		    
		    // load image into canvas
		    
		    canvas.loadImage(image);
		    
		    int selected = 0;
		    
		    if (id > 0 && allData.frameData[id-1] != null) {
			selected = allData.frameData[id-1].getSelected();
		    } else {
			selected = allData.frameData[id].getSelected();
		    }
		    
		    if (selected < FrameData.SINGLE_BOXES) {
			setSingleSelected(selected);
		    } else {
			setGroupSelected(selected-FrameData.SINGLE_BOXES);
		    }
		    
		} catch (IOException ioe) {
		    JOptionPane.showMessageDialog(null,("Unable to load: \n"+tempFileName+"\n from directory "+seqName+"\n"+
							"At last frame in the sequence"),
						  "Load Error", JOptionPane.WARNING_MESSAGE);
		    id--;
		    ioe.printStackTrace();
		}
		
		if (id > max) {
		    max = id;
		}
	    }
	} else {
	    JOptionPane.showMessageDialog(null,("Currently only set up for sequences of \n"+AllData.FRAMES+" frames"+
					       "alter the AllData.FRAMES variable if more is req"),
					 "Frame error", JOptionPane.WARNING_MESSAGE);
	}
    }

    /** 
     * Loads the next frame with the currently stored data which may be blank.
     */
    public void loadNext() {
	
	//PTC
	if(performCheck && 
		!CheckConsistency.checkFrame(allData.frameData[id])) return;
	if (id+1 < AllData.FRAMES) {

	    if (checkGroupBoxes()) {
		
		++id;
		
		String tempFileName = "";
		// figure out name of next file
		if (id < 10) {
		    if (hundreds) {
			tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-3)*/
			    +"00"+id+".jpg";
		    } else {
			tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-4)*/
			    +"000"+id+".jpg";
		    }
		} else if (id < 100) {
		    if (hundreds) {
			tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-3)*/
			    +"0"+id+".jpg";
		    } else {
			tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-4)*/
			    +"00"+id+".jpg";
		    }
		} else if (id < 1000) {
		    if (hundreds) {
			tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-3)*/
			    +id+".jpg";
		    } else {
			tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-4)*/
			    +"0"+id+".jpg";
		    }
		} else {
		    tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-4)*/
			+id+".jpg";
		}
		
		// load image file ...
		try {
		    imageFile = new File(seqName+"/JPEGS/"+tempFileName);
		    image = ImageIO.read(imageFile);
		    
		    fileName = tempFileName;
		    
		    if (hundreds) {
			frameNumber.setText("Frame: "+ id + " in sequence "+ seqName/*.substring(0,seqName.lastIndexOf('.')-3)*/);
		    } else {
			frameNumber.setText("Frame: "+ id + " in sequence "+ seqName/*.substring(0,seqName.lastIndexOf('.')-4)*/);
		    }
		    
		    // if prev frame not null reload its contents into new frame,
		    // otherwise create a new empty frame data object
		    
		    if (allData.frameData[id] == null) {
			allData.frameData[id] = new FrameData();
		    }
		    
		    // load image into canvas
		    
		    canvas.loadImage(image);
		    
		    int selected = 0;
		    
		    if (id > 0 && allData.frameData[id-1] != null) {
			selected = allData.frameData[id-1].getSelected();
		    } else {
			selected = allData.frameData[id].getSelected();
		    }
		    
		    if (selected < FrameData.SINGLE_BOXES) {
			setSingleSelected(selected);
		    } else {
			setGroupSelected(selected-FrameData.SINGLE_BOXES);
		    }
		    
		} catch (IOException ioe) {
		    JOptionPane.showMessageDialog(null,("Unable to load: \n"+seqName+"\n from directory "+seqName+"\n"+
							"At last frame in the sequence"),
					      "Load Error", JOptionPane.WARNING_MESSAGE);
		    id--;
		    ioe.printStackTrace();
		}
		
		if (id > max) {
		    max = id;
		}
		// require for play
		this.paint(getGraphics());
	    }
	} else {
	    JOptionPane.showMessageDialog(null,("Currently only set up for sequences of \n"+AllData.FRAMES+" frames"+
					       "alter the AllData.FRAMES variable if more is req"),
					 "Frame error", JOptionPane.WARNING_MESSAGE);
	}
    }
    
    /**
     * Copies the currently selected box into the next data structure
     */
    public void copyBoxNext() {
	
	//PTC
	if(performCheck && 
		!CheckConsistency.checkFrame(allData.frameData[id])) return;
	if (id+1 < AllData.FRAMES) {

	    int selected = allData.frameData[id].getSelected();
	    
	    if (selected < FrameData.SINGLE_BOXES && !allData.frameData[id].singleBox[selected].getBoxDrawn()) {
		JOptionPane.showMessageDialog(null,("Single Box "+selected+" not drawn"),
					      "Copy Error", JOptionPane.WARNING_MESSAGE);
		return;
		
	    } else if (selected >= FrameData.SINGLE_BOXES) {
		if (! allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBoxDrawn()) {
		    JOptionPane.showMessageDialog(null,("Group Box "+(selected-FrameData.SINGLE_BOXES)+" not drawn"),
						  "Copy Error", JOptionPane.WARNING_MESSAGE);
		    return;
		} else {
		    boolean[] sBoxes = allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getIndBoxes();
		    Rectangle gBox = allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBox();
		    for (int j = 0; j < sBoxes.length; j++) {
			if (sBoxes[j]) {
			    if (allData.frameData[id+1] != null && allData.frameData[id+1].singleBox[j].getBoxDrawn()) {
				Rectangle sBox = allData.frameData[id+1].singleBox[j].getBox();
			    
				if (! (sBox.getX() >= gBox.getX() &&
				       (sBox.getX() + sBox.getWidth()) <= (gBox.getX() + gBox.getWidth()) &&
				       sBox.getY() >= gBox.getY() &&
				       (sBox.getY() + sBox.getHeight()) <= (gBox.getY() + gBox.getHeight()))) {
				   /*GREGOR JOptionPane.showMessageDialog(null,("Invalid Group Box object - Individual\n"+
									"Box "+j+" is no longer contained within Group Box\n"+
									+j+" in the next frame"),
								  "Group Box Error", JOptionPane.ERROR_MESSAGE); */
				   sBox.getY();//GREGOR return;
				}
			    } else {
				JOptionPane.showMessageDialog(null,("Invalid Group Box object - Individual\n"+
								    "Box "+j+" is not yet initialised in the\n"+
								    "next frame"),
							      "Group Box Error", JOptionPane.ERROR_MESSAGE);
			    return;
			    }
			}
		    }
		}
	    }
	    
	    if (checkGroupBoxes()) {
		
		++id;
		
		String tempFileName = "";
		// figure out name of next file
		if (id < 10) {
		    if (hundreds) {
			tempFileName = seqName+"00"+id+".jpg";
		    } else {
			tempFileName = seqName+"000"+id+".jpg";
		    }
		} else if (id < 100) {
		    if (hundreds) {
			tempFileName = seqName+"0"+id+".jpg";
		    } else {
			tempFileName = seqName+"00"+id+".jpg";
		    }
		} else if (id < 1000) {
		    if (hundreds) {
			tempFileName = seqName+id+".jpg";
		    } else {
			tempFileName = seqName+"0"+id+".jpg";
		    }
		} else {
		    tempFileName = seqName+id+".jpg";
		}
		
		// load image file ...
		try {
		    imageFile = new File(seqName+"/JPEGS/"+tempFileName);
		    image = ImageIO.read(imageFile);
		    
		    fileName = tempFileName;
		    
		    if (hundreds) {
			frameNumber.setText("Frame: "+ id + " in sequence "+ seqName/*.substring(0,seqName.lastIndexOf('.')-3)*/);
		    } else {
			frameNumber.setText("Frame: "+ id + " in sequence "+ seqName/*.substring(0,seqName.lastIndexOf('.')-4)*/);
		    }
		    
		    
		    // create a new empty frame data object if null
		    
		    if (allData.frameData[id] == null) {
			allData.frameData[id] = new FrameData();
		    }
		    
		    // load image into canvas
		    
		    canvas.loadImage(image);
		    
		    if (selected < FrameData.SINGLE_BOXES) {
			allData.frameData[id].singleBox[selected] = 
			    new SingleBox(allData.frameData[id-1].singleBox[selected].getTruths(),
					  allData.frameData[id-1].singleBox[selected].getBox(),
					  allData.frameData[id-1].singleBox[selected].getAxis(),
					  allData.frameData[id-1].singleBox[selected].getLine(),
					  allData.frameData[id-1].singleBox[selected].getBody());
		    } else {
			allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES] = 
			    new GroupBox(allData.frameData[id-1].groupBox[selected-FrameData.SINGLE_BOXES].getTruths(),
					 allData.frameData[id-1].groupBox[selected-FrameData.SINGLE_BOXES].getBox(),
					 allData.frameData[id-1].groupBox[selected-FrameData.SINGLE_BOXES].getAxis(),
					 allData.frameData[id-1].groupBox[selected-FrameData.SINGLE_BOXES].getLine(),
					 allData.frameData[id-1].groupBox[selected-FrameData.SINGLE_BOXES].getIndBoxes());
		    }
		    
		    if (id > 0 && allData.frameData[id-1] != null) {
			selected = allData.frameData[id-1].getSelected();
		    } else {
			selected = allData.frameData[id].getSelected();
		    }
		    
		    if (selected < FrameData.SINGLE_BOXES) {
			setSingleSelected(selected);
		    } else {
			setGroupSelected(selected-FrameData.SINGLE_BOXES);
		    }
		    
		} catch (IOException ioe) {
		    JOptionPane.showMessageDialog(null,("Unable to load: \n"+seqName+"\n from directory "+seqName+"\n"+
							"At last frame in the sequence"),
						  "Load Error", JOptionPane.WARNING_MESSAGE);
		    id--;
		    ioe.printStackTrace();
		}
		
		if (id > max) {
		    max = id;
		}
		this.paint(getGraphics());
	    }
	} else {
	    JOptionPane.showMessageDialog(null,("Currently only set up for sequences of \n"+AllData.FRAMES+" frames"+
					       "alter the AllData.FRAMES variable if more is req"),
					 "Frame error", JOptionPane.WARNING_MESSAGE);
	}
    }
	
	public void copyBodyNext(){
		//PTC
		if(performCheck && 
			!CheckConsistency.checkFrame(allData.frameData[id])) return;		
		int selected = allData.frameData[id].getSelected();
		if (selected>=FrameData.SINGLE_BOXES){
			JOptionPane.showMessageDialog(null,("Group Box Selected, select a single box to copy the body"),
						  "Copy Error", JOptionPane.WARNING_MESSAGE);
		return;			
		}
		if (selected < FrameData.SINGLE_BOXES && !allData.frameData[id].singleBox[selected].getBoxDrawn()) {
			JOptionPane.showMessageDialog(null,("Single Box "+selected+" not drawn"),
						  "Copy Error", JOptionPane.WARNING_MESSAGE);
			return;

		}
		if (checkGroupBoxes()) {				
			++id;
	    
			String tempFileName = "";
			// figure out name of next file
			if (id < 10) {
			if (hundreds) {
				tempFileName = seqName+"00"+id+".jpg";
			} else {
				tempFileName = seqName+"000"+id+".jpg";
			}
			} else if (id < 100) {
			if (hundreds) {
				tempFileName = seqName+"0"+id+".jpg";
			} else {
				tempFileName = seqName+"00"+id+".jpg";
			}
			} else if (id < 1000) {
			if (hundreds) {
				tempFileName = seqName+id+".jpg";
			} else {
				tempFileName = seqName+"0"+id+".jpg";
			}
			} else {
			tempFileName = seqName+id+".jpg";
			}
	
			// load image file ...

			try {
			imageFile = new File(seqName+"/JPEGS/"+tempFileName);
			image = ImageIO.read(imageFile);
		
			fileName = tempFileName;
		
			if (hundreds) {
				frameNumber.setText("Frame: "+ id + " in sequence "+ seqName);
			} else {
				frameNumber.setText("Frame: "+ id + " in sequence "+ seqName);
			}
		
		
			// create a new empty frame data object if next one is null
		
			if (allData.frameData[id] == null) {
				allData.frameData[id] = new FrameData();
			}
		
			// load image into canvas
		    
			canvas.loadImage(image);

		
			if (selected < FrameData.SINGLE_BOXES) {
				Body body=allData.frameData[id-1].singleBox[selected].getBody();
				Body newbody=body.cloneBody();
				Rectangle box=allData.frameData[id].singleBox[selected].getBox();
				if (box!=null){
					if (newbody.isNull()==false){
						newbody=newbody.fitBodyinBox(box);
						allData.frameData[id].singleBox[selected].setBody(newbody);	
					}else{
						newbody=new Body();
						allData.frameData[id].singleBox[selected].setBody(newbody);	
						JOptionPane.showMessageDialog(null,"Attempting to copy body from a box with no body draw",
										  "Copy Body Error", JOptionPane.WARNING_MESSAGE);						
					}

				}else{
					JOptionPane.showMessageDialog(null,"Box has not been draw in frame "+id+" yet",
									  "Copy Body Error", JOptionPane.WARNING_MESSAGE);						
				}
			}

			if (id > 0 && allData.frameData[id-1] != null) {
				selected = allData.frameData[id-1].getSelected();
			} else {
				selected = allData.frameData[id].getSelected();
			}

			if (selected < FrameData.SINGLE_BOXES) {
				setSingleSelected(selected);
			} else {
				setGroupSelected(selected-FrameData.SINGLE_BOXES);
			}

			} catch (IOException ioe) {
			JOptionPane.showMessageDialog(null,("Unable to load: \n"+seqName+"\n from directory "+seqName+"\n"+
								"At last frame in the sequence"),
							  "Load Error", JOptionPane.WARNING_MESSAGE);
			id--;
			ioe.printStackTrace();
			}
	    
			if (id > max) {
			max = id;
			}
			// require for play
			this.paint(getGraphics());
		}
		}

	
    /**
     * Copies the currently selected box's attributes into the next data structure
     */
    public void copyTruthsNext() {
	
	//PTC
	if(performCheck && 
		!CheckConsistency.checkFrame(allData.frameData[id])) return;
	int selected = allData.frameData[id].getSelected();
	
	if (selected < FrameData.SINGLE_BOXES && !allData.frameData[id].singleBox[selected].getBoxDrawn()) {
	    JOptionPane.showMessageDialog(null,("Single Box "+selected+" not drawn"),
					  "Copy Error", JOptionPane.WARNING_MESSAGE);
	    return;

	} else if (selected >= FrameData.SINGLE_BOXES && ! allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].getBoxDrawn()) {
	    JOptionPane.showMessageDialog(null,("Group Box "+(selected-FrameData.SINGLE_BOXES)+" not drawn"),
					  "Copy Error", JOptionPane.WARNING_MESSAGE);
	    return;
	}

	if (checkGroupBoxes()) {
	    
	    ++id;
	    
	    String tempFileName = "";
	    // figure out name of next file
	    if (id < 10) {
		if (hundreds) {
		    tempFileName = seqName+"00"+id+".jpg";
		} else {
		    tempFileName = seqName+"000"+id+".jpg";
		}
	    } else if (id < 100) {
		if (hundreds) {
		    tempFileName = seqName+"0"+id+".jpg";
		} else {
		    tempFileName = seqName+"00"+id+".jpg";
		}
	    } else if (id < 1000) {
		if (hundreds) {
		    tempFileName = seqName+id+".jpg";
		} else {
		    tempFileName = seqName+"0"+id+".jpg";
		}
	    } else {
		tempFileName = seqName+id+".jpg";
	    }
	
	    // load image file ...

	    try {
		imageFile = new File(seqName+"/JPEGS/"+tempFileName);
		image = ImageIO.read(imageFile);
		
		fileName = tempFileName;
		
		if (hundreds) {
		    frameNumber.setText("Frame: "+ id + " in sequence "+ seqName);
		} else {
		    frameNumber.setText("Frame: "+ id + " in sequence "+ seqName);
		}
		
		
		// create a new empty frame data object if next one is null
		
		if (allData.frameData[id] == null) {
		    allData.frameData[id] = new FrameData();
		}
		
		// load image into canvas
		    
		canvas.loadImage(image);

		
		if (selected < FrameData.SINGLE_BOXES) {
		    allData.frameData[id].singleBox[selected].setTruths(
									allData.frameData[id-1].singleBox[selected].getTruths());
		} else {
		    allData.frameData[id].groupBox[selected-FrameData.SINGLE_BOXES].setTruths(
											      allData.frameData[id-1].groupBox[selected-FrameData.SINGLE_BOXES].getTruths());
		}

		if (id > 0 && allData.frameData[id-1] != null) {
		    selected = allData.frameData[id-1].getSelected();
		} else {
		    selected = allData.frameData[id].getSelected();
		}

		if (selected < FrameData.SINGLE_BOXES) {
		    setSingleSelected(selected);
		} else {
		    setGroupSelected(selected-FrameData.SINGLE_BOXES);
		}

	    } catch (IOException ioe) {
		JOptionPane.showMessageDialog(null,("Unable to load: \n"+seqName+"\n from directory "+seqName+"\n"+
						    "At last frame in the sequence"),
					      "Load Error", JOptionPane.WARNING_MESSAGE);
		id--;
		ioe.printStackTrace();
	    }
	    
	    if (id > max) {
		max = id;
	    }
	    // require for play
	    this.paint(getGraphics());
	}
    }

    /** 
     * Jumps to the frame frameNo in the current sequence, an exception occrus if the
     * frame does not exist.
     */
    public void jumpToFrame(int frameNo) {
	
	//PTC
	if(performCheck && 
		!CheckConsistency.checkFrame(allData.frameData[id])) return;
	if (frameNo > AllData.FRAMES) {
	    JOptionPane.showMessageDialog(null,("No sequence has "+AllData.FRAMES+" frames, please \nenter a"+
						" a frame number between 0 and \n"+AllData.FRAMES),
					      "Load Error", JOptionPane.WARNING_MESSAGE);

	} else if (checkGroupBoxes()) {

	    String tempFileName = "";
	    
	    // figure out name of next file
	    if (frameNo < 10) {
		if (hundreds) {
		    tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-3)*/
			+"00"+frameNo+".jpg";
		} else {
		    tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-4)*/
			+"000"+frameNo+".jpg";
		}
	    } else if (frameNo < 100) {
		if (hundreds) {
		    tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-3)*/
			+"0"+frameNo+".jpg";
		} else {
		    tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-4)*/
			+"00"+frameNo+".jpg";
		}
	    } else if (frameNo < 1000) {
		if (hundreds) {
		    tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-3)*/
			+frameNo+".jpg";
		} else {
		    tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-4)*/
			+"0"+frameNo+".jpg";
	    }
	    } else {
		tempFileName = seqName/*.substring(0,seqName.lastIndexOf(".")-4)*/
		    +frameNo+".jpg";
	    }
	    
	    try {
		imageFile = new File(seqName+"/JPEGS/"+tempFileName);
		image = ImageIO.read(imageFile);
		
		fileName = tempFileName;
		int oldId = id;
		id = frameNo;
		if (id > max) {
		    max = id;
		}
		
		if (hundreds) {
		    frameNumber.setText("Frame: "+ frameNo + " in sequence "+ seqName/*.substring(0,seqName.lastIndexOf('.')-3)*/);
		} else {
		    frameNumber.setText("Frame: "+ frameNo + " in sequence "+ seqName/*.substring(0,seqName.lastIndexOf('.')-4)*/);
		}
		
		// if prev frame not null reload its contents into new frame,
		// otherwise check next frame and reload its contents into new frame
		// otherwise create a new empty frame data object
		if (allData.frameData[id] == null) {
		    if (allData.frameData[id-1] != null) {
			allData.frameData[id] = new FrameData(allData.frameData[id-1].getSingleBoxes(),
							      allData.frameData[id-1].getGroupBoxes());
		    } else if (allData.frameData[id+1] != null) {
			allData.frameData[id] = new FrameData(allData.frameData[id+1].getSingleBoxes(),
							      allData.frameData[id+1].getGroupBoxes());
		    } else {
			allData.frameData[id] = new FrameData();
		    }
		}
		
		// load image into canvas
		
		canvas.loadImage(image);
		
		int selected = 0;
		
		// get old selected if not null, if is null use this frames selected
		if (allData.frameData[oldId] != null) {
		    selected = allData.frameData[oldId].getSelected();
		} else {
		    selected = allData.frameData[id].getSelected();
		}
		    
		if (selected < FrameData.SINGLE_BOXES) {
		    setSingleSelected(selected);
		} else {
		    setGroupSelected(selected-FrameData.SINGLE_BOXES);
		}
		
	    } catch (IOException ioe) {
		JOptionPane.showMessageDialog(null,("Unable to load: \n"+tempFileName+"\n from directory "+seqName+"\n"+
						"At last frame in the sequence"),
					      "Load Error", JOptionPane.WARNING_MESSAGE);
		ioe.printStackTrace();
	    }
	}
    }
	
    /**
     * Resets all the highlighted data in the current frame.
     */
    public void resetFrame() {
	allData.frameData[id] = new FrameData();
	
	int selected = allData.frameData[id].getSelected();
	    
	if (selected < FrameData.SINGLE_BOXES) {
	    singleBoxUpdateDisplay(selected);
	} else {
	    groupBoxUpdateDisplay(selected-FrameData.SINGLE_BOXES);
	}
    }

    /**
     * Resets all the data in the current sequence.
     */
    public void resetAll() {
	allData = new AllData();
	
	// to prevent NullPointerExceptions must initialise
	// the currently selected structure
	
	allData.frameData[id] = new FrameData();

	int selected = allData.frameData[id].getSelected();
	    
	if (selected < FrameData.SINGLE_BOXES) {
	    singleBoxUpdateDisplay(selected);
	} else {
	    groupBoxUpdateDisplay(selected-FrameData.SINGLE_BOXES);
	}
    }

    /**
     * Redraws the rectangle, called when some changed has been made to the datastructure.
     */
    public void drawRect() {
	    
	    if ((canvas!=null) && (point1!=null) && (point2!=null)){
			// put in boundaries if goes out of boundaries
			if (point1.x > canvas.getImageWidth()) {
			    point1.x = canvas.getImageWidth()-1;
			}
			if (point1.x < 0) {
			    point1.x = 0;
			}
			if (point2.x > canvas.getImageWidth()) {
			    point2.x = canvas.getImageWidth()-1;
			}
			if (point2.x < 0) {
			    point2.x = 0;
			}
			if (point1.y > canvas.getImageHeight()) {
			    point1.y = canvas.getImageHeight()-1;
			}
			if (point2.y > canvas.getImageHeight()) {
			    point2.y = canvas.getImageHeight()-1;
			}
			if (point1.y < 0) {
			    point1.y = 0;
			} 
			if (point2.y < 0) {  
			    point2.y = 0;	
			} 
			 
			LinkedList returnList = canvas.drawBox(point1,point2,allData.frameData[id]);
		
			//System.out.println(allData.frameData[id].toString());
		
			int select = allData.frameData[id].getSelected();
		
			Object o;
			    
			// must have a box drawn if list is of length 2
			// saves 2 calls to getBoxDrawn for both individual and
			// group boxes
			if (returnList.size() == 2) {
		
			    o = returnList.removeFirst();
			    if (o instanceof Rectangle) {
				Rectangle r = new Rectangle((int)((Rectangle)o).getX()/CAVIARGUI.SCALE,
							   (int)((Rectangle)o).getY()/CAVIARGUI.SCALE,
							   (int)((Rectangle)o).getWidth()/CAVIARGUI.SCALE,
							   (int)((Rectangle)o).getHeight()/CAVIARGUI.SCALE);
				if (select < FrameData.SINGLE_BOXES) {
				    // set rectangle to half coordinates - floor function of coord/2 by def in Java
				    allData.frameData[id].singleBox[select].setBox(r);
				} else {
				    allData.frameData[id].groupBox[select-FrameData.SINGLE_BOXES].setBox(r);
				}
			    }
			    o = returnList.removeFirst();
			    if (o instanceof Line2D.Float) {
				Line2D.Float line = new Line2D.Float((float)((Line2D.Float)o).getX1()/CAVIARGUI.SCALE,
								     (float)((Line2D.Float)o).getY1()/CAVIARGUI.SCALE,
								     (float)((Line2D.Float)o).getX2()/CAVIARGUI.SCALE,
								     (float)((Line2D.Float)o).getY2()/CAVIARGUI.SCALE);
				if (select < FrameData.SINGLE_BOXES) {
				    allData.frameData[id].singleBox[select].setLine(line);
				} else {
				    allData.frameData[id].groupBox[select-FrameData.SINGLE_BOXES].setLine(line);
				}
			    }
			}
	    }
    }


 	public Rectangle getBoxforCurrentSelection(){
		Rectangle box=null;
		int index = allData.frameData[id].getSelected();
		if (index < FrameData.SINGLE_BOXES) {
			if (allData.frameData[id].singleBox[index].getBoxDrawn()==true){
				box=allData.frameData[id].singleBox[index].getBox();			
			}
		} else {
			if (allData.frameData[id].groupBox[index-FrameData.SINGLE_BOXES].getBoxDrawn()==true){
				box=allData.frameData[id].groupBox[index-FrameData.SINGLE_BOXES].getBox();	
			}
		} 
	return box;		
 	}

	public boolean isASingleBoxSelected(){
		boolean single=false;
		int index = allData.frameData[id].getSelected(); 
		if (index < FrameData.SINGLE_BOXES)
			single=true;
		return single;		
	}
 	
 	/**
 	 * Returns the current selected single box, if it has been draw
 	 * @return
 	 */
 	
 	public SingleBox getSingleBoxSelected(){
 		SingleBox single=null;
		int index = allData.frameData[id].getSelected(); 		
		if (index < FrameData.SINGLE_BOXES) {
			if (allData.frameData[id].singleBox[index].getBoxDrawn()==true){
				single=allData.frameData[id].singleBox[index];			
			}
		}		
		return single;
 	}
    
    public Circle FitCircleInBox(Circle circle, Rectangle box){
//    	System.out.println("box is "+box.getX()+" "+box.getY()+" ancho "+box.getWidth()+" alto "+box.getHeight());
 //   	System.out.println("circle its "+circle.getX()+" "+circle.getY()+" "+circle.getR());
    	if ((circle.getX()-circle.getR()) < (box.getX())){
    		circle.setR((int)(circle.getX()-box.getX()));
    	}
    	if ((circle.getX()+circle.getR()) > (box.getX()+box.getWidth())){
			circle.setR((int)(box.getX()+box.getWidth()-circle.getX()));
    	}
		if ((circle.getY()-circle.getR()) < (box.getY())){
			circle.setR((int)(circle.getY()-box.getY()));
		}
		if ((circle.getY()+circle.getR()) > (box.getY()+box.getHeight())){
			circle.setR((int)(box.getY()+box.getHeight()-circle.getY()));
		}
		if (circle.getR()<0){
			circle=null;    
			JOptionPane.showMessageDialog(this,("Circle reset: Out of the box, restart drawing circle"),
							  "Drawing Warning", JOptionPane.WARNING_MESSAGE);	
			System.out.println("Setting circle to null in fitcircle function");
		}			
				    	
    	return circle;
    }

	public void drawBody(boolean dragMouse){
		SingleBox single=getSingleBoxSelected();
		Body bodyData=single.getBody();
		if (single!=null){
			Body body = new Body();
			if (bodyPartSelectedisCircle()){
				Circle circle=drawCircle();
				if (circle!=null)
					if ((dragMouse==false) && (circle.getR()==0)){
						circle=null;		
						JOptionPane.showMessageDialog(null,("Circle ratio=0: reseting current circle"),
										  "Drawing Warning", JOptionPane.WARNING_MESSAGE);
					}			
				if (circle!=null)
					body.setCirclewithType(circle);
				switch(bodyPartSelected){
					case BODY_SEL_HEAD:bodyData.setHead(circle);break;
					case BODY_SEL_RIGHT_HAND:bodyData.setRighthand(circle);break;
					case BODY_SEL_LEFT_HAND:bodyData.setLefthand(circle);break;
					case BODY_SEL_RIGHT_FOOT:bodyData.setRightfoot(circle);break;
					case BODY_SEL_LEFT_FOOT:bodyData.setLeftfoot(circle);break;
				}
				canvas.drawBody(body,allData.frameData[id],false);
			}
			if (bodyPartSelectedisLine()){
				Line2D.Float l=drawLine();
				Line2D.Float shLine=null;
				if (l!=null){
					if (bodyPartSelected==BODY_SEL_RIGHT_SHOULDER){
						shLine=new Line2D.Float((int)l.getX1(),(int)l.getY1(),(int)l.getX2(),(int)l.getY2());
						body.setShoulderLine(shLine);			
					}		
					if (bodyPartSelected==BODY_SEL_LEFT_SHOULDER){
						shLine=new Line2D.Float((int)l.getX2(),(int)l.getY2(),(int)l.getX1(),(int)l.getY1());
						body.setShoulderLine(shLine);				
					}
				}
				bodyData.setShoulderLine(shLine); 
				canvas.drawBody(body,allData.frameData[id],false);				
			}
			if (bodyPartSelected==BODY_SEL_GAZE){
				body.setGaze(bodyData.getGaze());
				body.setHead(bodyData.getHead());
				canvas.drawBody(body,allData.frameData[id],true);
			}
		}else{
			JOptionPane.showMessageDialog(null,("Current box selected is a group box"),
							  "Warning", JOptionPane.WARNING_MESSAGE);				
		}
	}

	public static double atan2(double y,double x){
		double angle=0;
		if ((x==0) && (y>0)) angle=90; 
		else if ((x==0) && (y<0)) angle=270;
		else if ((x>0) && (y==0)) angle=0;
		else if ((x<0) && (y==0)) angle=180;
		else if ((x==0) && (y==0)) angle=0;
		else
		{
			angle=Math.atan(y/x)*180/Math.PI;
			if ((x<0) && (y<0)) angle=angle+180;
			if ((x>0) && (y<0)) angle=angle+360;
			if ((x<0) && (y>0)) angle=180+angle;
		}	
		return angle;
	} 
    
	public Circle drawCircle(){
		Rectangle box=getBoxforCurrentSelection();
		Circle circle=null;
		if ((point1!=null) && (point2!=null)){	
			int r=(int)(Math.sqrt(Math.pow(point1.getX()-point2.getX(),2)+Math.pow(point1.getY()-point2.getY(),2)));
			int type=getCircleTypeforSelection();
	
			if ((type!=-1) && (box!=null)){
				circle=new Circle((int)(point1.getX()/CAVIARGUI.SCALE),
								(int)(point1.getY()/CAVIARGUI.SCALE),(int)(r/CAVIARGUI.SCALE),type);
				circle=FitCircleInBox(circle,box);
				if (circle!=null){
					this.point1=new Point((int)(circle.getX()*CAVIARGUI.SCALE),(int)(circle.getY()*CAVIARGUI.SCALE));
					this.point2=new Point((int)((circle.getX()+circle.getR())*CAVIARGUI.SCALE),(int)(circle.getY()*CAVIARGUI.SCALE));
				}
			}else{
				JOptionPane.showMessageDialog(null,("Its not possible to set a circle, the current selected box has not been drawn yet"),
								  "Drawing Warning", JOptionPane.WARNING_MESSAGE);					
			}
		}
		return circle; 
	}

	public Line2D.Float drawLine(){
		Rectangle box=getBoxforCurrentSelection();
		Line2D.Float line=null;
		if ((point1!=null) && (point2!=null)){
			Point pt1=fitCoordinatestoBox((int)(point1.getX()/CAVIARGUI.SCALE),(int)(point1.getY()/CAVIARGUI.SCALE),box);
			Point pt2=fitCoordinatestoBox((int)(point2.getX()/CAVIARGUI.SCALE),(int)(point2.getY()/CAVIARGUI.SCALE),box);
			this.point1=new Point((int)(pt1.getX()*CAVIARGUI.SCALE),(int)(pt1.getY()*CAVIARGUI.SCALE));
			this.point2=new Point((int)(pt2.getX()*CAVIARGUI.SCALE),(int)(pt2.getY()*CAVIARGUI.SCALE));
			line=new Line2D.Float(pt1,pt2);	
		}
		return line;		
	}

	
	public void printFrame(int frame){
		allData.printFrame(frame);
	}
	public void printFrames(){
		allData.printFrames();
	}
	
	public void setProperty(boolean ind,String Property,String Value,int id, int from, int to){
		allData.setProperty(ind,Property,Value,id,from,to);
	}

}
